program makeok; {utility for C64 project}
{$I-}
uses dos,crt;
const FileNumber_=8;
      ErrorNumber__=250;
type ByteTable=array[1..FileNumber_,1..ErrorNumber__] of byte;
     ModifiedTable=array[1..FileNumber_,1..ErrorNumber__] of boolean;
     PosTable=array[1..ErrorNumber__] of word;
     OkTable=array[1..ErrorNumber__] of word;
     ErrorTable=record
                  PT:PosTable;
                  BT:ByteTable;
                  MT:ModifiedTable;
                  OT:OkTable;
                end;
     FileNames=array[1..FileNumber_] of string;
     TBuffer=array[0..65534] of byte;
     PBuffer=^TBuffer;
     FileByte=file of byte;
var  ET:ErrorTable;
     FN:FileNames;
     Ris:array[0..255] of byte;
     FileNumber:byte; {contain the number of file found}
     Buf1,Buf2:PBuffer;
     F,F1,G:FileByte;
     Length:word;
     ErrorNumber:byte;    {actual errors number}
     ErrorNumber_:byte;   {actual max errors number}
     Option:byte;

const erNoFile   = 1;  {no file found}
      erNoMemory = 2;  {out of memory}
      erNo3      = 3;  {minimum 3 file}
      erReading  = 4;  {error reading a file}
      erOpening  = 5;  {error opening a file}
      erSize     = 6;  {different size of file}
      erTooError = 7;  {too many errors found}
      erCreating = 8;  {error creating output file}
      erSaving   = 9;  {error saving output file}
      erClosing  = 10; {error closing file}
      erInvalid  = 11; {invalid option error}

      opNothing = 0;
      opN       = 1;   {option Number}
      opM       = 2;   {option Make}
      opS       = 3;   {option Super Make}

const HexDigits:array[0..15] of char='0123456789ABCDEF';

type Header4Byte=array[1..4] of byte;
     HexString=string[8];

function HexByte(B:byte):HexString;
var Temp:HexString;
begin
  Temp[0]:=#2;
  Temp[1]:=HexDigits[B shr 4];
  Temp[2]:=HexDigits[B and $F];
  HexByte:=Temp;
end;

function HexWord(W:word):HexString;
var Temp:HexString;
begin
  Temp[0]:=#4;
  Temp[1]:=HexDigits[W shr 12];
  Temp[2]:=HexDigits[(W shr 8) and $F];
  Temp[3]:=HexDigits[(W shr 4) and $F];
  Temp[4]:=HexDigits[W and $F];
  HexWord:=Temp;
end;

procedure WriteError(e:byte);
begin
  writeln;
  case e of
   erNoFile:  writeln('No *.T@* file found');
   erNoMemory:writeln('Out of memory');
   erNo3:     writeln('3 files are the minimum to the process');
   erReading: writeln('Error reading a file');
   erOpening: writeln('Error opening a file');
   erSize:    writeln('Files are different in size');
   erTooError:writeln('Too many errors found');
   erCreating:writeln('Error creating output file');
   erSaving:  writeln('Error saving output file');
   erClosing: writeln('Error closing open file');
   erInvalid: writeln('Invalid option');
  end;
  halt(e);
end;

procedure SearchFile;   {search for T@x file}
var DirInfo: SearchRec;
begin
  FileNumber:=0;
  FindFirst('*.T@*', Archive, DirInfo);
  while (DosError = 0) and (FileNumber<FileNumber_) do
  begin
    inc(FileNumber);
    FN[FileNumber]:=DirInfo.Name;
    FindNext(DirInfo);
  end;
end;

procedure OpenFile(var f:FileByte; n:string);
begin
  assign(f,n);
  reset(f);
  if IOResult<>0 then WriteError(erOpening);
end;

procedure UpdatePosition(i:byte;j:word);
var k:byte;             {i point to FileNumber (col)}
                        {j point to Buffer bytes}
begin
  if i=2 then begin
                inc(ErrorNumber);
                if ErrorNumber>ErrorNumber_ then WriteError(erTooError);
                ET.PT[ErrorNumber]:=j;
                ET.BT[1,ErrorNumber]:=buf1^[j];
                ET.BT[2,ErrorNumber]:=buf2^[j];
                ET.MT[1,ErrorNumber]:=true;
                ET.MT[2,ErrorNumber]:=true;
                exit;
              end;
  k:=1;
  while (k<=ErrorNumber) and (ET.PT[k]<>j) do
   inc(k);
  if (k<=ErrorNumber)
    then begin
           ET.BT[i,k]:=buf2^[j];
           ET.MT[i,k]:=true;
         end
   else begin
           inc(ErrorNumber);
           if ErrorNumber>ErrorNumber_ then WriteError(erTooError);
           ET.PT[ErrorNumber]:=j;
           ET.BT[1,ErrorNumber]:=buf1^[j];
           ET.BT[i,ErrorNumber]:=buf2^[j];
           ET.MT[1,ErrorNumber]:=true;
           ET.MT[i,ErrorNumber]:=true;
         end;
end;

procedure UpdateTable(i:byte); {update the byte table}
var j,k:word;        {i point to FileNumber (col)}
begin
                     {j point to Buffer bytes}
  for j:=0 to length-1 do
      if Buf1^[j]<>Buf2^[j] then UpdatePosition(i,j);
                     {j point to FileNumber (col)}
                     {k point to ErrorNumber (row)}
  for j:=2 to i do
    for k:=1 to ErrorNumber do
      if ET.MT[j,k]=false then begin
                                 ET.MT[j,k]:=true;
                                 ET.BT[j,k]:=ET.BT[1,k];
                               end;
end;

procedure MakeTable;    {create the byte table}
var i:byte;      {i point to FileNumber of table (col)}
begin
  ErrorNumber:=0;
  OpenFile(f,FN[1]);
  Length:=FileSize(f);
  BlockRead(file(f),Buf1^,FileSize(f));
  if IOResult<>0 then WriteError(erReading);
  for i:=2 to FileNumber do
    begin
      OpenFile(f1,FN[i]);
      BlockRead(file(f1),Buf2^,filesize(f1));
      if IOResult<>0 then WriteError(erReading);
      if FileSize(f1)<>Length then WriteError(erSize);
      UpdateTable(i);
      Close(f1);
      if IOResult<>0 then WriteError(erClosing);
    end;
  close(f);
  if IOResult<>0 then WriteError(erClosing);
end;

procedure EraseTable;
var i,j:byte;
begin
  for i:=1 to ErrorNumber_ do
    for j:=1 to FileNumber_ do
     ET.MT[j,i]:=false;
end;

procedure Choose;
var i,j:byte;
    Value,Pos:byte;

function Max(a,b:byte; var p:byte):byte;
begin
  if Ris[b]>a then begin
                     Max:=Ris[b];
                     p:=b
                   end
              else Max:=a;
end;

begin
  for j:=1 to ErrorNumber do
    begin
      for i:=0 to 255 do
        Ris[i]:=0;
      for i:=1 to FileNumber do
          inc(Ris[ET.BT[i,j]]);
      Value:=0;
      Pos:=0;
      for i:=0 to 255 do
        begin
          Value:=Max(Value,i,Pos);
        end;
      ET.OT[j]:=Pos;
    end;
end;

procedure WriteTable;
var i,j:byte;
    er:byte;
begin
  if Option=opM then
    begin
      gotoxy(14,wherey);
      for i:=1 to ErrorNumber do
        begin
          write(HexWord(ET.PT[i]),' ');
        end;
      writeln(' ER');
      for i:=1 to FileNumber do
        begin
          write(FN[i]);
          gotoxy(14,wherey);
          er:=0;
          for j:=1 to ErrorNumber do
            if ET.BT[i,j]=ET.OT[j]
              then begin
                     highVideo;
                     write(' ',HexByte(ET.BT[i,j]),'  ');
                     lowVideo;
                   end
              else begin
                     write(' ',HexByte(ET.BT[i,j]),'  ');
                     inc(er);
                   end;
          writeln(' ',HexByte(er));
        end;
    end
    else begin
           writeln('             ERROR');
           for i:=1 to FileNumber do
             begin
               write(FN[i]);
               gotoxy(15,wherey);
               er:=0;
               for j:=1 to ErrorNumber do
                 if ET.BT[i,j]<>ET.OT[j] then inc(er);
               writeln(HexByte(er));
             end;
         end;
end;

procedure Correct;
var i:byte;
begin
  for i:=1 to ErrorNumber do
      Buf1^[ET.PT[i]]:=ET.OT[i];
end;

procedure SaveResult;
begin
  assign(g,'RIS@@@@@.T@0');
  rewrite(g);
  if IOResult<>0 then WriteError(erCreating);
  BlockWrite(file(g),Buf1^,Length);
  if IOResult<>0 then WriteError(erSaving);
  close(g);
  if IOResult<>0 then WriteError(erClosing);
end;

procedure SearchParam;
var S:string;
begin
  Option:=opNothing;
  S:=ParamStr(1);
  if (ParamCount=0) or (S='/h') or (S='/H')
    then begin
           writeln('Usage: MAKEOK  /option');
           writeln;
           writeln('/h, /H  This help page');
           writeln('/n, /N  Number of error found');
           writeln('/m, /M  Make the correct file (max 12 errors)');
           writeln('/s, /S  Super Make the correct file (max 250 errors)');
           halt(0);
         end;
  if (S='/n') or (S='/N') then Option:=opN;
  if (S='/m') or (S='/M') then begin
                                 Option:=opM;
                                 ErrorNumber_:=12;
                               end;
  if (S='/s') or (S='/S') then begin
                                 Option:=opS;
                                 ErrorNumber_:=250;
                               end;
  if Option=opNothing then WriteError(erInvalid);
end;

procedure SearchError;
var Error:word;
    i,k:byte;

procedure Search12(var Error:word);
var j:word;
begin
  for j:=0 to length-1 do
      if Buf1^[j]<>Buf2^[j] then inc(Error);
end;

begin
  for k:=1 to FileNumber-1 do
   begin
     OpenFile(f,FN[k]);
     Length:=FileSize(f);
     BlockRead(file(f),Buf1^,FileSize(f));
     if IOResult<>0 then WriteError(erReading);
     for i:=k+1 to FileNumber do
       begin
         Error:=0;
         OpenFile(f1,FN[i]);
         BlockRead(file(f1),Buf2^,filesize(f1));
         if IOResult<>0 then WriteError(erReading);
         if FileSize(f1)<>Length then WriteError(erSize);
         Search12(Error);
         Close(f1);
         if IOResult<>0 then WriteError(erClosing);
         writeln(FN[k],'  ==  ',FN[i],'   ',Error,' error(s)');
       end;
     close(f);
     if IOResult<>0 then WriteError(erClosing);
     writeln;
   end;
end;

begin
  clrscr;
  writeln('MAKEOK utility ver 1.00');
  writeln;
  SearchParam;
  GetMem(Buf1,sizeof(TBuffer));
  GetMem(Buf2,sizeof(TBuffer));
  if (Buf1=nil) or (Buf2=nil) then WriteError(erNoMemory);
  SearchFile;
  if FileNumber=0 then WriteError(erNoFile);
  if FileNumber<3 then Writeerror(erNo3);
  if (Option=opM) or (Option=opS) then
   begin
     EraseTable;
     MakeTable;
     Choose;
     WriteTable;
     Correct;
     SaveResult;
   end;
  if Option=opN then SearchError;
  FreeMem(Buf1,sizeof(TBuffer));
  FreeMem(Buf2,sizeof(TBuffer));
end.


11/02/98  1:45   30   : procedure generali, e per tabella
14/02/98    45    5   : aggiunte /S /N
          ....   ...
          2:30   35