DOSSEG
LOCALS
JUMPS
.286
.MODEL small

_STACK segment para stack 'stack'
  dw 200h dup(?)
  EndStack LABEL BYTE
_STACK ends
assume ss:_stack

.DATA

TRUE    equ 1
FALSE   equ 0
IPORT   equ 3bdh     ; parallel control port register
BITMASK equ 80h
RATE    equ 680      ; sperimentally value
VIDEO_SEG equ 0B800h ; color video segment
stNormal equ 0  ; line of normal
st1line  equ 1  ; line of no file found
st2line  equ 2  ; line of one file found (not read)
st3line  equ 3  ; line of one file read (not save)

erNormal equ 0  ; line of normal
er1line  equ 1  ; line of no error
er2line  equ 2  ; line of checksum error
er3line  equ 3  ; line of wrong type
er4line  equ 4  ; line of stop by esc

ilmChoose   equ  0; line for standard info
ilmInput    equ  1; line for input name file
ilmFile     equ  2; line for error in file name
ilmPLoad    equ  3; line for press tape (loading)
ilmStop     equ  4; line for interrupt by ESC key
ilmPath     equ  5; line for path not found
ilmAlready  equ  6; line for file already exists
ilmGeneric  equ  7; line for generic file error
ilmWrong    equ  8; line for wrong type found
ilmNoFile   equ  9; line for no file yet found
ilmChk      equ 10; line for checksum error
ilmNoSave   equ 11; line for no save error
ilmErSave   equ 12; line for save error
ilmExit     equ 13; line for exit but not saved
ilmNotSaved equ 14; line for not saved
ilmNoName   equ 15; line for no name set

ilm0  db 0Fh,'Select highlighted options desired                                  '
ilm1  db 0Fh,'Insert output filename:                                             '
ilm2  db 04h,'ERROR: No name of file is specified (press any key to continue)     '
ilm3  db 0Fh,'Press PLAY on tape (Use ESC key to abort operation)                 '
ilm4  db 04h,'WARNING: Operation interrupt by user (press any key to continue)    '
ilm5  db 04h,'ERROR: Path not found (press any key to continue)                   '
ilm6  db 04h,'WARNING: Output file already exists. Overwrite (Yes/No) ?           '
ilm7  db 04h,'ERROR: Internal DOS error in file creating routine (press any key)  '
ilm8  db 04h,'WARNING: Found an wrong header file. Press Y to continue anyway     '
ilm9  db 04h,'ERROR: Can''t read a file before found it with S option (press a key)'
ilm10 db 04h,'WARNING: Probably read error, save with W option is not raccomanded '
ilm11 db 04h,'ERROR: There''s nothing file to save (press any key to continue)     '
ilm12 db 04h,'ERROR: There''s a problem saving output file (press any key)         '
ilm13 db 04h,'WARNING: File not saved, are you sure to exit (Yes/No) ?            '
ilm14 db 04h,'WARNING: File not saved, continue anyway (Yes/No) ?                 '
ilm15 db 04h,'ERROR: No file name are selected with O option (press any key)      '
InfoLineTable dw offset ilm0
              dw offset ilm1
              dw offset ilm2
              dw offset ilm3
              dw offset ilm4
              dw offset ilm5
              dw offset ilm6
              dw offset ilm7
              dw offset ilm8
              dw offset ilm9
              dw offset ilm10
              dw offset ilm11
              dw offset ilm12
              dw offset ilm13
              dw offset ilm14
              dw offset ilm15

NBit       db 0        ; number of bit to read
CharRead   db 0        ; the reading char
Char       db ?        ; a char for local compare
Chk        db ?        ; contain progressive checksum
StopRead   db FALSE    ; TRUE if we must not continue to read
Key        db ?        ; key press used by int 09 handler
OldValue   dw 0        ; store the value of counter
CursorForm dw ?        ; hold the actual form of the cursor
FHandle    dw ?        ; file handle
FileLength dw ?        ; length of input file
SegBuffer  dw ?        ; segment of memory buffer
Counter    dw 1        ; counter for attribute memory pointer
Status     db stNormal ; status of read process
Error      db erNormal ; error of read process
MotorFlag  db FALSE    ; the state of motor
OutFileSet db FALSE    ; if the name of output file is set
NormalKeyboard db TRUE ; choose the type of keyboard (TRUE=bios)

HexDigit db '0123456789ABCDEF'

TempBuffer db ?        ; temporally buffer for hex to string conversion
           db ?,?,?,?

InputBuffer db 40   ; max length
            db ?    ; effective length
            rept 43
              db ?
            endm
FPath db ?          ; file path (first is length)
      rept 28
        db ?
      endm
FName db ?          ; file name (first is length)
      rept 8
        db ?
      endm
FExtension db ?     ; file extension (first is length)
           rept 4
             db ?
           endm

FHeader     db 2,19,19,5 ; Commodore 64 Turbo Tape File + version
Type1       db ?         ; contain the header type (01/02)
Type2       db ?         ; contain the header type (00)
Checksum    db ?         ; contain the checksum of file
FileInfo label byte
  StartAddr dw ?         ; start of program in C64 memory
  StopAddr  dw ?         ; stop of program in C64 memory
  Type3     db ?
  FileName label byte
      rept 0bbh          ; file name
            db ?
      endm
  FileName_ label byte
FileInfo_ label byte

Int09Save dd ?

VideoMask label byte
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0
db ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0
db '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4
db '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4
db '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4, '', 4
db '', 4, '', 4, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'b',15, 'y',15, ' ', 0, 'I',15, 'C',15, 'E',15
db ' ', 0, 'T',15, 'E',15, 'A',15, 'M',15, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '', 5, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0
db '', 5, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, '', 5
db ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0, '', 5, '', 5
db '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '6', 2, '4', 2,  16, 2
db  17, 2, 'P', 2, 'C', 2, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'v', 9, 'e', 9, 'r', 9, ' ', 0, '1', 9,  46, 9
db '0', 9, '0', 9, '-', 9, '1', 9, '9', 9, '9', 9, '7', 9, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '',13, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '',13, '',13, '',13, '',13, '',13, ' ', 0, ' ', 0
db '',13, ' ', 0, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, ' ', 0, '',13, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 's', 9, 'h', 9, 'a', 9, 'r', 9, 'e', 9, 'w', 9
db 'a', 9, 'r', 9, 'e', 9, ' ', 9, 's', 9, 'o', 9, 'f', 9, 't', 9
db '.', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'M',15, 'o', 7, 't', 7, 'o', 7, 'r', 7
db ' ', 7, 'O', 7, 'n', 7, '/', 7,'O', 7,  'f', 7, 'f', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'O',15, 'u', 7
db 't', 7, 'p', 7, 'u', 7, 't', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, 'n', 7, 'a', 7, 'm', 7, 'e', 7
db ':', 7, ' ', 7, 'n', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'S',15, 'e', 7, 'a', 7,  'r', 7,'c', 7
db 'h', 7, ' ', 7, 'f', 7, 'o', 7, 'r', 7, ' ', 7, 'f', 7, 'i', 7
db 'l', 7, 'e', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'W',15, 'r', 7
db 'i', 7, 't', 7, 'e', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'R',15, 'e', 7,'a', 7,  'd', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'e', 7, 'X',15
db 'i', 7, 't', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, 'T', 7, 'y', 7, 'p', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'S', 7, 't', 7, 'a', 7, 't', 7
db 'u', 7, 's', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7, 'n', 7
db 'd', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'F', 7, 'i', 7, 'r', 7, 's', 7, 't', 7, ' ', 7
db 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7
db 'n', 7, 'd', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 'r', 7, 'e', 7, 'a', 7, 'd', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'S', 7, 'e', 7, 'c', 7, 'o', 7, 'n', 7, 'd', 7
db ' ', 7, 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'r', 7, 'e', 7, 'a', 7
db 'd', 7, ' ', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 's', 7, 'a', 7, 'v', 7, 'e', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'N', 7, 'a', 7, 'm', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'E', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'e', 7, 'r', 7
db 'r', 7, 'o', 7, 'r', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'T', 7, 'y', 7, 'p', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'c', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7
db 's', 7, 'u', 7, 'm', 7, ' ', 7, 'e', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'N', 7, 'u', 7, 'm', 7, 'b', 7, 'e', 7, 'r', 7
db ' ', 7, 'o', 7, 'f', 7, ' ', 7, 'b', 7, 'y', 7, 't', 7, 'e', 7
db ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'w', 7, 'r', 7, 'o', 7, 'n', 7, 'g', 7
db ' ', 7, 't', 7, 'y', 7, 'p', 7, 'e', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'C', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7, 's', 7
db 'u', 7, 'm', 7, ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 's', 7, 't', 7, 'o', 7, 'p', 7, ' ', 7
db 'f', 7, 'o', 7, 'r', 7, 'c', 7, 'e', 7, 'd', 7, ' ', 7, 'b', 7
db 'y', 7, ' ', 7, 'E', 7, 'S', 7, 'C', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

ProgInfo db 'READER ver 1.00 (C) ICE TEAM inc. 1997-98', 0Dh, 0Ah, '$'
er0      db 'Thanks to have use this program.$'
er1	 db 'No eougth memory: program aborted.$'
erTable  dw offset er0
	 dw offset er1

.CODE

CHANGE_CURSOR_POSITION macro pos
        mov  ah,02h
        mov  bh,0         ; page=0
        mov  dx,pos       ; DH=row DL=col.
        int  10h          ; change cursor position
endm

WRITE_CHAR macro char, attr
        mov  ax,0900h+char
        mov  bx,0000h+attr ; page=0
        mov  cx,1          ; 1 char
        int  10h           ; write one caracter
endm

GET_INT_VECT macro num, vect
        mov  ax,35h*256+num   ; DOS: get int vect
        int  21h
        mov  word ptr[vect],bx
        mov  word ptr[vect+2],es
endm


SET_INT_VECT macro num, vect, par
        push ds
        ifidn <par>,<[]>
             mov  dx,word ptr [vect]
             mov  ax,word ptr [vect+2]
             mov  ds,ax
        else
             mov  dx,offset(vect)
             mov  ax,seg(vect)
             mov  ds,ax
        endif
        mov  ax,25h*256+num   ; DOS: set int vect
        int  21h
        pop  ds
endm

READ_CHAR macro
 @@loop_:
        mov  ah,01
        int  16h
        jz   @@loop_       ; AL=char read if ZF=0

        mov  ah,00
        int  16h           ; AL=char read
endm

WRITE_NCHAR macro char, attr, num
        mov  ax,0900h+char
        mov  bx,00+attr   ; page 0 + attrib
        mov  cx,num
        int  10h          ; write cx char
endm

WRITE_IN_FILE macro num, ind, par
         mov  ah,40h
         mov  bx,FHandle
         ifidn <par>,<[]>
           xor  ch,ch
           mov  cl,num
           inc  cl
         else
           mov  cx,num
         endif
         mov  dx,offset(ind)
         int  21h
endm

; interrupt routine for the 09h keyboard service
Int09 proc far
        push ds
        push ax
        pushf
        mov  ax,@data
        mov  ds,ax
        cmp  NormalKeyboard,TRUE
        jne  NotNormal
        call Int09Save
        pop  ax
        pop  ds
        iret

  NotNormal:
        in   al,60h             ; read key scan code
        mov  Key,al
        in   al,61h             ; read status
        mov  ah,al
        or   al,80h             ; set reset bit
        out  61h,al             ; out reset bit
        xchg ah,al
        out  61h,al             ; out previous status

        cmp  Key,01h            ; ESC key
        jne  cont

  SetExit:
        mov  StopRead,TRUE

  cont:
        cli
        mov  al,20h
        out  20h,al            ; end of interrupt
        popf
        pop  ax
        pop  ds
        iret
Int09 endp


ReadBit proc                  ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE       ; if cx<RATE bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBit endp

ReadChar proc              ; read one char in CharRead
        mov  NBit,08h
  @@loop:
        call ReadBit       ; Carry=bit readed
        rcl  CharRead,1
         cmp  StopRead,TRUE
         je   @@exit
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,Counter
        mov  al,byte ptr es:[bx]
        add  al,16
        and  al,01111111b
        mov  byte ptr es:[bx],al
        add  Counter,2
        cmp  Counter,4001
        jne  @@cont
        mov  Counter,1
    @@cont:
        pop  es
    ifdef VIDEO              ; change border color
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        inc  byte ptr es:[415]
        inc  byte ptr es:[417]

        inc  byte ptr es:[409]
        inc  byte ptr es:[423]
        inc  byte ptr es:[249]
        inc  byte ptr es:[251]
        inc  byte ptr es:[253]
        inc  byte ptr es:[255]
        inc  byte ptr es:[257]
        inc  byte ptr es:[259]
        inc  byte ptr es:[261]
        inc  byte ptr es:[263]
        inc  byte ptr es:[569]
        inc  byte ptr es:[571]
        inc  byte ptr es:[573]
        inc  byte ptr es:[575]
        inc  byte ptr es:[577]
        inc  byte ptr es:[579]
        inc  byte ptr es:[581]
        inc  byte ptr es:[583]

        pop  es
    endif
        dec  NBit
        jne  @@loop
        mov  al,CharRead   ; return AL=char readed
  @@exit:
        ret
ReadChar endp

ReadHeader proc            ; read the header of tape file
  @@loop1:
        call ReadBit       ; try to read a bit
        rcl  CharRead,1
         cmp  StopRead,TRUE
         je   @@exit
        cmp  CharRead,02h  ; repeat until reached a 02h input char
        jne  @@loop1
  @@loop2:
         cmp  StopRead,TRUE
         je   @@exit
        call ReadChar
        cmp  al,02h
        je   @@loop2       ; read and discard all the 02h char
        mov  Char,09h
  @@loop3:
        cmp  Char,al       ; search for 09h, 08h, ... 02h 01h chars
        jne  @@loop1
        call ReadChar
         cmp  StopRead,TRUE
         je   @@exit
        dec  Char
        jne  @@loop3
  @@exit:
        ret                ; return last char readed
ReadHeader endp

ReadFileInfo proc          ; read info of a tape file
        mov  ax,ds
        mov  es,ax
        mov  di,offset(FileInfo)
        cld
  @@loop:
        call ReadChar
        stosb
        cmp  di,offset(FileInfo_)
        jne  @@loop
        ret
ReadFileInfo endp

ReadFile proc              ; read data of a tape file
         mov  ax,SegBuffer
         mov  es,ax
         mov  di,StartAddr
         mov  Chk,0
  @@loop:
         call ReadChar       ; read a char (in AL)
         mov  es:di,al       ; save data
         inc  di
         xor  Chk,al         ; calculate checksum
         cmp  di,StopAddr
         jb   @@loop
         call ReadChar
         mov  Checksum,al    ; store checksum read in file
         ret
ReadFile endp

WriteVideoMask proc        ; write the video mask
       mov  ax,VIDEO_SEG
       mov  es,ax
       xor  di,di
       mov  si,offset(VideoMask)
       mov  cx,25*80
       rep  movsw
       ret
WriteVideoMask endp

HideCursor proc           ; make the cursor invisible
       mov  ah,03
       xor  bh,bh         ; page 0
       int  10h           ; info about corsor
       mov  CursorForm,cx ; form of the cursor

       mov  ah,01h
       mov  ch,20h        ; invisible cursor
       int  10h           ; set cursor form
       ret
HideCursor endp

ShowCursor proc           ; make the cursor visible
       mov  ah,01h
       mov  cx,CursorForm
       int  10h           ; set form of the cursor as normal
       ret
ShowCursor endp

WriteInfoLine proc        ; write message into info line (BL set message)
        mov  dx,1702h     ; row=24 col.=3
        xor  bh,bh        ; page =0
        add  bl,bl        ; bl=number of infomessage
        mov  bp,[bx+offset InfoLineTable]
        mov  bl,ds:[bp]   ; attrib.
        inc  bp
        mov  ax,@data
        mov  es,ax        ; ES:BP=string
        mov  ax,1300h
        mov  cx,68        ; string length
        int  10h          ; write infoline message
        ret
WriteInfoLine endp

InputName proc            ; read input file name by keyboard

        CHANGE_CURSOR_POSITION 171Ah  ; row=24 col.=27
        mov  ah,0Ah
        mov  dx,offset(InputBuffer)
        int  21h          ; input a string
        ret
InputName endp

StringCopy proc           ; copy one string (ds:si) in another (es:di)
        sub  dx,bx
        cmp  ax,bx
        jb   lower
        mov  ax,bx
  lower:
        stosb             ; save length
        mov  cx,ax
        add  bx,si
        rep  movsb        ; copy string
        mov  si,bx
        ret
StringCopy endp

SplitName proc            ; split file name component
        mov  ax,@data
        mov  es,ax
        cld
        mov  si,offset(InputBuffer+1)
        lodsb             ; al=length of input name string
        mov  dl,al
        xor  dh,dh        ; dx=length
        mov  bx,dx
        or   bx,bx        ; ?=0
        je   zero
  @@loop:
        cmp  byte ptr [bx+si-1],'\'
        je   zero
        cmp  byte ptr [bx+si-1],':'
        je   zero
        dec  bx
        jne  @@loop
  zero:
        mov  ax,28        ; max path length
        mov  di,offset(FPath)
        call StringCopy
        xor  bx,bx
        jmp  for_name
  continue:
        cmp  byte ptr [bx+si],'.'
        je   name_found
        inc  bx
  for_name:
        cmp  bx,dx
        jne  continue
  name_found:
        mov  ax,08
        mov  di,offset(FName)
        call StringCopy
        mov  bx,dx
        mov  ax,0004
        mov  di,offset(FExtension)
        call StringCopy
        ret
SplitName endp

UpdateFileName proc       ; write actul file name into his line
        CHANGE_CURSOR_POSITION 0642h ; row=7 col.=67
        mov  si,offset(FName+1)
        mov  cl,byte ptr [FName] ; length of name
        xor  ch,ch
        cld
  @@loop:
        lodsb
        cmp  al,'a'
        jb   @@not
        cmp  al,'z'
        ja   @@not
        and  al,11011111b  ; make char upper
  @@not:
        mov  ah,0Eh
        xor  bh,bh        ; page=0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop

        mov  si,offset(FExtension+1)
        mov  cl,byte ptr [FExtension] ; length of extension
  @@loop1:
        lodsb
        cmp  al,'a'
        jb   @@not1
        cmp  al,'z'
        ja   @@not1
        and  al,11011111b  ; make char upper
  @@not1:
        mov  ah,0Eh
        mov  bh,00;07h    ; page=0 color=7
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop1
                          ; calculate if name<max name
        mov  cl,byte ptr [FName]
        add  cl,byte ptr [FExtension]
        mov  ch,12
        sub  ch,cl
        jz   @@exit      ; if not equal we must delete the extra
        mov  cl,ch
        xor  ch,ch
  @@loop2:
        mov  ax,0E20h
        mov  bh,00        ; page 0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop2
  @@exit:
        ret
UpdateFileName endp

WriteNumInfo proc         ; write numeric string info
        mov  dl,11h                   ; col=dl
        mov  ax,1300h
        mov  bx,000Fh                 ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,byte ptr [TempBuffer] ; string length
        mov  bp,offset(TempBuffer+1)
        int  10h                      ; write string es:bp
        ret
WriteNumInfo endp

WriteFileInfo proc        ; write info about header of tape file to video
        mov  ax,@data
        mov  es,ax        ; es used byte int 10h
        mov  al,Type1
        call HexByte      ; convert hex byte to string
        mov  dh,0Dh       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,StartAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Eh       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,StopAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Fh       ; row
        call WriteNumInfo ; write numeric string info
        mov  dx,1011h     ; row/col.
        mov  ax,1300h
        mov  bx,000Fh     ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,60        ; string length
        mov  bp,offset(FileName)
        int  10h          ; write string es:bp
        ret
WriteFileInfo endp

WriteFileData proc        ; write info about data part of tape file to video
        mov  ax,@data
        mov  es,ax        ; es used byte int 10h
        mov  al,Type2
        call HexByte      ; convert hex byte to string
        mov  dh,12h       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,StopAddr
        mov  bx,StartAddr
        sub  ax,bx
        mov  FileLength,ax
        call HexWord      ; convert hex word to string
        mov  dh,13h
        call WriteNumInfo ; write numeric string info
        mov  al,Checksum
        call HexByte      ; convert hex byte to string
        mov  dh,14h       ; row
        call WriteNumInfo ; write numeric string info
        ret
WriteFileData endp

WriteSpace proc           ; erase video file information
        CHANGE_CURSOR_POSITION 0D11h
        WRITE_NCHAR ' ', 0Fh, 2         ; line for type1
        CHANGE_CURSOR_POSITION 0E11h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for start addrs
        CHANGE_CURSOR_POSITION 0F11h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for stop addrs
        CHANGE_CURSOR_POSITION 1011h
        WRITE_NCHAR ' ', 0Fh, 60        ; line for name
        CHANGE_CURSOR_POSITION 1211h
        WRITE_NCHAR ' ', 0Fh, 2         ; line for type2
        CHANGE_CURSOR_POSITION 1311h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for number of byte
        CHANGE_CURSOR_POSITION 1411h
        WRITE_NCHAR ' ', 0Fh, 2         ; line for chksum
        ret
WriteSpace endp

HexByte proc              ; convert hex byte to string
        mov  byte ptr [TempBuffer],2
        xor  bh,bh
        mov  bl,al                      ; al=hex
        shr  bl,4                       ; hi nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ah
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ah
        ret
HexByte endp

HexWord proc              ; convert hex word to string
        mov  byte ptr [TempBuffer],4    ; string length
        xor  bh,bh
        mov  bl,ah
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ch
        mov  bl,ah
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ch
        mov  bl,al
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+3],ch
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+4],ch
        ret
HexWord endp

ChangeStatus proc         ; change color of status line
        mov  dl,Status
        cmp  dl,stNormal  ; line of normal
        je   @@Normal
        cmp  dl,st1line   ; line of no file found
        je   stline1
        cmp  dl,st2line   ; line of one file found (not read)
        je   stline2
        mov  bx,0707h     ; 1=07, 2=07, 3=0F color
        mov  dh,0Fh
        jmp  modify
  @@Normal:
        mov  bx,0707h     ; 1=07, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline1:
        mov  bx,0F07h     ; 1=0F, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline2:
        mov  bx,070Fh     ; 1=0F, 2=0F, 3=07 color
        mov  dh,07h
  modify:
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  di,13*80*2+51*2+1  ; line of no file found
        mov  cx,001Ah
  @@loop:
        mov  es:di,bh
        add  di,2
        loopne @@loop
        mov  di,14*80*2+51*2+1  ; line of one file found (not read)
        mov  cx,001Ah
  @@loop1:
        mov  es:di,bl
        add  di,2
        loopne @@loop1
        mov  di,15*80*2+51*2+1  ; line of one file read (not save)
        mov  cx,001Ah
  @@loop2:
        mov  es:di,dh
        add  di,2
        loopne @@loop2
        ret
ChangeStatus endp

ChangeError proc          ; change color of error line
        mov  dl,Error
        cmp  dl,erNormal  ; line of normal
        je   @@Normal
        cmp  dl,er1line   ; line of no error
        je   erLine1
        cmp  dl,er2line   ; line of checksum error
        je   erLine2
        cmp  dl,er3line   ; line of wrong type
        je   erLine3
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,070Fh     ; 3=07, 4=0F
        jmp  modify2
  @@Normal:
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine1:
        mov  bx,0F07h     ; 1=0F, 2=07
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine2:
        mov  bx,070Fh     ; 1=07, 2=0F
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine3:
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,0F07h     ; 3=0F, 4=07
  modify2:
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  di,17*80*2+51*2+1  ; line of no error
        mov  cx,001Ah
  @@loop:
        mov  es:di,bh
        add  di,2
        loopne @@loop
        mov  di,18*80*2+51*2+1  ; line of checksum error
        mov  cx,001Ah
  @@loop1:
        mov  es:di,bl
        add  di,2
        loopne @@loop1
        mov  di,19*80*2+51*2+1  ; line of wrong type error
        mov  cx,001Ah
  @@loop2:
        mov  es:di,dh
        add  di,2
        loopne @@loop2
        mov  di,20*80*2+51*2+1  ; line of stop by esc error
        mov  cx,001Ah
  @@loop3:
        mov  es:di,dl
        add  di,2
        loopne @@loop3
        ret
ChangeError endp

MotorOn proc              ; on the cassette motor

        mov  MotorFlag,TRUE

        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 0Fh          ; 'O', attrib.=15
        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=14
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOn endp

MotorOff proc             ; off the cassette motor

        mov  MotorFlag,FALSE

        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=13
        WRITE_CHAR 4Fh 0Fh           ; 'O', attrib=15
        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOff endp

OpenFile proc             ; create a new file
        mov  ax,5B02h
        xor  cx,cx                    ; write only
        mov  dx,offset(InputBuffer+2) ; asciiz name
        int  21h                      ; create new file
        jc   @@error
  @@ok:
        mov  FHandle,ax               ; store file handle
        clc                           ; file ok
        ret
  @@error:
        cmp  ax,50h                   ; file already exists error
        je   @@already
  @@error2:
        cmp  ax,03h                   ; path not found error
        je   @@path
        mov  bl,ilmGeneric
        call WriteInfoLine            ; line for generic file error
        jmp  @@exit_
  @@already:
        mov  bl,ilmAlready
        call WriteInfoLine            ; line for file already exists
  @@loop:
        mov  ah,01
        int  16h
        jz   @@loop        ; AL=char read if ZF=0
        mov  ah,00
        int  16h           ; AL=char read

        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   @@rewrite
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        je   @@exit
  @@rewrite:
        mov  ax,3C02h
        mov  dx,offset(InputBuffer+2) ; asciiz name
        xor  cx,cx
        int  21h                      ; create a file
        jc   @@error2
        jmp  @@ok

  @@path:
         mov  bl,ilmPath
         call WriteInfoLine            ; line for path not found
  @@exit_:
         READ_CHAR
  @@exit:stc                           ; file error
         ret
OpenFile endp

SaveFile proc              ; save the file
         WRITE_IN_FILE 4+1+1+1+2+2+1, FHeader
         jc   SaveError
         cmp  ax,cx
         jnz  SaveError
         std                         ; down direction
         mov  di,offset(FileName_)-1 ; end of name
         mov  cx,0bbh
         mov  ax,ds
         mov  es,ax
         mov  al,' '
         repe scasb                  ; search for first <> space char
         inc  di
         sub  di,offset(FileName)-1  ; calculate effective name length
         jbe  @@nothing
         mov  ax,di
         mov  [FileName-1],al        ; save length
         jmp  @@cont
  @@nothing:
         mov  [FileName-1],1         ; assume length=1
  @@cont:
         WRITE_IN_FILE [FileName-1], offset(FileName)-1, []
         jc   SaveError
         cmp  ax,cx
         jnz  SaveError

         mov  cx,FileLength          ; length of file data
         mov  bx,FHandle
         mov  dx,StartAddr
         mov  ax,SegBuffer
         mov  ds,ax
         mov  ah,40h
         int  21h                    ; write CX byte DS:DX in file
         mov  bx,@data               ; restore DS
         mov  ds,bx
         jc   SaveError
         cmp  ax,cx
         jnz  SaveError
         clc
         ret
  SaveError:
         mov  bl,ilmErSave
         call WriteInfoLine         ; line for save error
         READ_CHAR
         stc
         ret
SaveFile endp

CloseFile proc             ; close a file
         mov  ah,3Eh
         mov  bx,FHandle
         int  21h                   ; file close
         ret
CloseFile endp

ExitProc proc              ; write exit message and exit from program
        mov  cl,al
        call InitScreen
        mov  dx,offset ProgInfo
        mov  ah,09h
        int  21h               ; write program information
        mov  bl,cl
        xor  bh,bh
        add  bl,bl
        mov  dx,[bx+offset erTable]
        mov  ah,09h
        int  21h               ; write exit message
        mov  al,cl
        mov  ah,4Ch
        int  21h               ; terminate with return code
        ret
ExitProc endp

InitScreen proc
        mov  ax,03h            ; Standard Mode
        int  10h
        ret
InitScreen endp

RestoreAttribute proc          ; restore black attribute to video
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,1
        mov  cx,2000           ; all video memory
  @@loop:
        mov  al,es:[bx]
        and  al,00001111b      ; set background=black
        mov  es:[bx],al
        add  bx,2
        loopnz @@loop
        pop  es
        mov  Counter,1         ; set to start of attributes
        ret
RestoreAttribute endp


Main:
                            ; set up stack and reduce memory allocation
        lea  bx,EndStack
        mov  cl,4
        shr  bx,cl          ; adjust to program
        inc  bx             ; round up
        mov  ax,ss
        add  bx,ax
        mov  ax,ds
        sub  bx,ax
        mov  ah,4Ah
        int  21h            ; change memory allocation

        mov  ax,@data
        mov  ds,ax

        mov  ah,48h
        mov  bx,4096
        int  21h                      ; get 64K dos memory
        jnc  @@noerror

        mov  al,01h                   ; terminate with 01 error code
        call ExitProc

  @@noerror:
        mov  SegBuffer,ax             ; store segment of buffer
        call InitScreen
        mov  NormalKeyboard,TRUE
	GET_INT_VECT 09h, Int09Save
        SET_INT_VECT 09h, Int09       ; insert int 09 handler

        call WriteVideoMask   ; write video mask page
        call HideCursor       ; make the cursor invisible
        call MotorOff
  loop_:
        mov  bl,ilmChoose
        call WriteInfoLine ; line for standard info
        call ChangeError   ; change error with actual error code
  loop__:
        READ_CHAR
        and  al,11011111b  ; make char upper

        cmp  al,'X'        ; exit from program
        je   exit

        cmp  al,'M'        ; motor on/off
        je   motor

        cmp  al,'S'        ; find a file from tape
        je   find

        cmp  al,'R'        ; read a file from tape
        je   read

        cmp  al,'O'        ; output filename
        je   output

        cmp  al,'W'        ; write file in PC format
        je   write

        jmp  loop__

  motor:
        cmp  MotorFlag,TRUE
        je   motor_off
        call MotorOn                ; make motor on
        jmp  loop_
  motor_off:
        call MotorOff               ; make motor off
        jmp  loop_

  find:
        cmp  Status,st3Line         ; is file read but not saved ?
        jne  find_
        mov  bl,ilmNotSaved
        call WriteInfoLine
        READ_CHAR
        and  al,11011111b           ; make char upper
        cmp  al,'Y'
        je   find_
        jmp  loop_

  find_:
        call WriteSpace             ; erase old video file information
        call MotorOn                ; make motor on
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
        mov  Status,st1Line        
        call ChangeStatus           ; line of no file found
        mov  Error,er1Line
        call ChangeError            ; line of no error
        mov  NormalKeyboard,FALSE
  @@loop:
        call ReadHeader             ; try to read an file header
        cmp  StopRead,TRUE          ; if interrupt by ESC key
        je   error_ilmStop          ; go error message
        cmp  CharRead,01            ; is correct header ?
        je   correct_header
        cmp  CharRead,02            ; is correct header ?
        je   correct_header

        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  Error,er3Line
        call ChangeError            ; line for wrong type error
        mov  bl,ilmWrong
        call WriteInfoLine          ; line for wrong type found
        mov  NormalKeyboard,TRUE
        READ_CHAR
        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   @@continue
        mov  Error,erNormal
        call ChangeError            ; line for normal error
        jmp  loop_
  @@continue:
        mov  NormalKeyboard,FALSE
        mov  Error,er1Line
        call ChangeError            ; line for no error
        mov  Status,st1Line
        call ChangeStatus           ; line for no file found
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press play on tape
        call MotorOn                ; make motor on
        jmp  @@loop                 ; no correct header found

  correct_header:
        mov  al,CharRead
        mov  Type1,al               ; save the header type

        call ReadFileInfo
        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  NormalKeyboard,TRUE
        mov  Status,st2Line
        call ChangeStatus           ; line of one file found (not read)
        call WriteFileInfo          ; write info about file
        jmp  loop_

  error_ilmStop:
        call RestoreAttribute
        mov  bl,ilmStop
        call WriteInfoLine          ; line for interrupt by ESC key
        mov  Status,stNormal
        call ChangeStatus           ; line for normal status
        mov  Error,er4Line
        call ChangeError            ; line for stop by esc
        mov  Error,erNormal
        mov  NormalKeyboard,TRUE
        mov  StopRead,FALSE
        call MotorOff               ; make motor off
        READ_CHAR
        jmp  loop_
  read:
        cmp  Status,st2Line         ; there's a file found ?
        jz   @@read
        mov  bl,ilmNoFile
        call WriteInfoLine          ; line for no file yet found
        READ_CHAR
        jmp  loop_
  @@read:
        call MotorOn                ; make motor on
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
        mov  NormalKeyboard,FALSE
  LocalLabel1:
  @@loop:
        call ReadHeader             ; try to read an file header
        cmp  StopRead,TRUE          ; if interrupt by ESC key
        je   error_ilmStop          ; go error message
        cmp  CharRead,00            ; is correct header ?
        je   @@Correct_header
        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  Error,er3Line
        call ChangeError            ; line for wrong type error
        mov  bl,ilmWrong
        call WriteInfoLine          ; line for wrong type found
        mov  NormalKeyboard,TRUE
        READ_CHAR
        and  al,11011111b           ; make char upper
        cmp  al,'Y'
        je   @@continue
        mov  Error,erNormal
        call ChangeError            ; line for normal error
        jmp  loop_
  @@continue:
        mov  NormalKeyboard,FALSE
        mov  Error,er1Line
        call ChangeError            ; line for no error
        mov  Status,st2Line
        call ChangeStatus           ; line for one file found
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press play on tape
        call MotorOn                ; make motor on
        jmp  @@loop                 ; no correct header found
  @@Correct_header:
        mov  Type2,00
        call ReadFile               ; read a file
        mov  Status,st3Line
        call ChangeStatus           ; line of one file read (not saved)
        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  NormalKeyboard,TRUE
        call WriteFileData          ; write info of file data
        mov  al,Chk
        cmp  al,CheckSum
        je   loop_
  CheckSumError:
        mov  Error,er2Line
        call ChangeError            ; line for checksum error
        mov  bl,ilmChk
        call WriteInfoLine          ; line for checksum error
        READ_CHAR
        jmp  loop_

  output:
        mov  bl,ilmInput
        call WriteInfoLine            ; line for input name file
        call ShowCursor               ; show cursor for input
        call InputName                ; enter name file
        call HideCursor               ; hide cursor
        call SplitName                ; estract component of file name
        cmp  byte ptr [FName],0       ; there's not name ?
        jz   Error_ilmFile            ; then error
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        cmp  byte ptr [FExtension],0  ; there's not extension ?
        jnz  there_is_ext
        mov  byte ptr [FExtension],4
        mov  byte ptr [Fextension+1],'.'
        mov  byte ptr [FExtension+2],'T'
        mov  byte ptr [FExtension+3],'@'
        mov  byte ptr [FExtension+4],'0'
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],'.'
        mov  byte ptr [bx+InputBuffer+3],'T'
        mov  byte ptr [bx+InputBuffer+4],'@'
        mov  byte ptr [bx+InputBuffer+5],'0'
        mov  byte ptr [bx+InputBuffer+6],0   ; asciiz string
        jmp  update_video_name
  there_is_ext:
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],0   ; asciiz string
  update_video_name:
        call UpdateFileName              ; write actul file name into his line
        mov  OutFileSet,TRUE             ; the file name is set
        jmp  loop_

  Error_ilmFile:
        mov  bl,ilmFile
        call WriteInfoLine               ; line for error in file name
        mov  byte ptr [FName],4
        mov  byte ptr [FName+1],'n'
        mov  byte ptr [FName+2],'o'
        mov  byte ptr [FName+3],'n'
        mov  byte ptr [FName+4],'e'
        mov  byte ptr [FExtension],1
        mov  byte ptr [FExtension+1],' '
        call UpdateFileName             ; write actul file name into his line
        mov  OutFileSet,FALSE           ; the file name is non set
        READ_CHAR
        jmp  loop_

  write:
        cmp  Status,st3Line         ; there's a file read ?
        jz   @@cont
        mov  bl,ilmNoSave
        call WriteInfoLine          ; line for no save error
  @@wait:
        READ_CHAR
        jmp  loop_
  @@cont:
        cmp  OutFileSet,TRUE        ; there's a good name set ?
        je   @@cont2
        mov  bl,ilmNoName
        call WriteInfoLine
        jmp  @@wait
  @@cont2:
        call OpenFile               ; create a new file
        jc   loop_                  ; jump if error opening file
        call SaveFile               ; save the file
        jc   @@close                ; jump if error writing file
        mov  Status,stNormal
        call WriteSpace             ; erase video file information
        call ChangeStatus           ; line for normal status
        mov  Error,erNormal
        call ChangeError            ; line for normal error
  @@close:
        call CloseFile              ; close a file
        jmp  loop_

  exit: cmp  Status,st3LIne         ; is a file read but not saved
        jne  goexit
        mov  bl,ilmExit             ; line for exit but not saved
        call WriteInfoLine
        READ_CHAR
        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   goexit
        jmp  loop_

  goexit:
        call ShowCursor
        SET_INT_VECT 09h, Int09Save, []   ; insert int 09 Bios
        xor  al,al
        call ExitProc          ; terminate with return code
END Main

$COMMENT
 PROC:
CloseFile            close a file
ChangeError          change color of error line
ChangeStatus         change color of status line
ExitProc             write exit message and exit from program
HexByte              convert hex byte to string
HexWord              convert hex word to string
HideCursor           make the cursor invisible
InitScreen           inizialize standard screen
InputName            read input file name by keyboard
MotorOff             off the cassette motor
MotorOn              on the cassette motor
OpenFile             create a new file
ReadBit              read one bit (carry=bit read)
ReadChar             read one char in CharRead
ReadFile             read data of a tape file
ReadFileInfo         read info of a tape file
ReadHeader           read the header of tape file
SaveFile             save the file
ShowCursor           make the cursor visible
SplitName            split file name component
StringCopy           copy one string (ds:si) in another (es:di)
UpdateFileName       write actul file name into his line
WriteFileData        write info about data part of tape file to video
WriteFileInfo        write info about header of tape file to video
WriteInfoLine        write message into info line (BL set message)
WriteNumInfo         write numeric string info
WriteSpace           erase video file information
WriteVideoMask       write the video mask
$

$COMMENT
 output file .T@0:
 00       02         : Commodore 64
 01       13h        : Turbo
 02       13h        : Tape
 03       05         : File
                     : versione 1.00

 04        01/02     : header format
 05        00        : file format
 06        chk       : Checksum of file data
 07        shi       : Start address low
 08        slo       : Start address hi
 09        ehi       : End address low
 0A        elo       : End address hi
 0B        00
 0C        len       : name length (1..$BB)
 0D        name
 ::        ::        : file name
 0D+len-1  name
 0E+len-1  data
 ::        ::        : file data
 eof       data
$

; 06/01/97    30
; 10/01/97    30
; 31/03/97  1:00
; 01/04/97  3:20
; 02/04/97  2:50
; 05/04/97    35
; 06/04/97  2:00
; 08/04/97  1:20
; 09/04/97    45
; 14/04/97  1:40
; 01/05/97        1:00
; 02/05/97    20  1:00
; 17/07/97     5    30
; 18/07/97     5
; 26/07/97    35
; 29/11/97    50          : + procedure per gestione ingresso/uscita programma
; 01/12/97    10          : + generazione effetto "caricameto"
; 01/12/97    10    40    : + modifica e verifica effetto "caricamento"
; 09/12/97    30          :   modifica a maschera
; 15/12/97    25          : sistemazione routine per nome
; 17/12/97          10    : correzione errore su stampa nome file
;           ....
;          17:15  3:20