DOSSEG
LOCALS
JUMPS
.286
.MODEL small

_STACK segment para stack 'stack'
  dw 200h dup(?)
  EndStack LABEL BYTE
_STACK ends
assume ss:_stack

.DATA

TRUE    equ 1
FALSE   equ 0
IPORT   equ 3bdh     ; parallel control port register
BITMASK equ 80h
RATE1   equ 1150     ; sperimentally value
RATE2   equ 1480     ; sperimentally value

erNormal equ 0   ; line of normal
er1line  equ 1   ; line of no error
er2line  equ 2   ; line of checksum error
er3line  equ 4   ; line of parity error
er4line  equ 8   ; line of manchester error
er5line  equ 16  ; line of less byte read
er6line  equ 32  ; line of stop by esc

stNormal equ 0       ; line of normal
st1line  equ 1       ; line of no file found
st2line  equ 2       ; line of one file found (not read)
st3line  equ 3       ; line of one file read (not save)

stFOUND_SEP equ 1    ; status: found * bit
stEND_READ  equ 2    ; status: end read a block
VIDEO_SEG equ 0B800h ; color video segment

Mode        db 0          ; contain satus of error in read a char
NBit        db 0          ; number of bit to read
CharRead    db 0          ; the reading char
Parity      db 0          ; for calculating parity of a byte
StopRead    db FALSE      ; TRUE if we must not continue to read
Key         db ?          ; key press used by int 09 handler
Count       db 0          ; contain the 89..81 or 09..01 sequence
OldValue    dw 0          ; store the value of counter
SegBuffer1  dw ?          ; segment of memory buffer 1
SegBuffer2  dw ?          ; segment of memory buffer 2
CursorForm  dw ?          ; hold the actual form of the cursor
FHandle     dw ?          ; file handle
FileLength1 dw ?          ; length of input file (copy 1)
FileLength2 dw ?          ; length of input file (copy 2)
NormalKeyboard    db TRUE ; choose the type of keyboard (TRUE=bios)
MotorFlag         db FALSE; the state of motor
OutFileSet        db FALSE; if the name of output file is set
ParityError       db 0    ; number of parity errors found
ParityErrorH1     db 0    ; number of parity errors found in 1 header
ParityErrorH2     db 0    ; number of parity errors found in 2 header
ParityErrorF1     db 0    ; number of parity errors found in 1 file data
ParityErrorF2     db 0    ; number of parity errors found in 2 file data
ManchesterError   db 0    ; number of manchester code error found
ManchesterErrorH1 db 0    ; number of manchester code error found in 1 header
ManchesterErrorH2 db 0    ; number of manchester code error found in 2 header
ManchesterErrorF1 db 0    ; number of manchester code error found in 1 file data
ManchesterErrorF2 db 0    ; number of manchester code error found in 2 file data
ChkH1             db ?    ; contain the calculated checksum of 1 header
ChkH2             db ?    ; contain the calculated checksum of 2 header
ChecksumF1        db ?    ; contain the checksum of 1 file data
ChecksumF2        db ?    ; contain the checksum of 2 file data
ChkF1             db ?    ; contain the calculated checksum of 1 file data
ChkF2             db ?    ; contain the calculated checksum of 2 file data
EffectiveReadH1   dw 0    ; effective bytes read in 1 header of file
EffectiveReadH2   dw 0    ; effective bytes read in 2 header of file
EffectiveReadF1   dw 0    ; effective bytes read in 1 file data
EffectiveReadF2   dw 0    ; effective bytes read in 2 file data
Counter     dw 1          ; counter for attribute memory pointer
Status      db stNormal   ; status of read process
Error       db erNormal   ; error of read process
Checksum    db ?          ; contain the checksum of file

HexDigit db '0123456789ABCDEF'

Int09Save dd ?       ; contain Bios Int 09 address

Copy2Name db 'COPY2@@@.T@0',0

TempBuffer db ?        ; temporally buffer for hex to string conversion
           db ?,?,?,?

InputBuffer db 40   ; max length
            db ?    ; effective length
            rept 43
              db ?
            endm
FPath db ?          ; file path (first is length)
      rept 28
        db ?
      endm
FName db ?          ; file name (first is length)
      rept 8
        db ?
      endm
FExtension db ?     ; file extension (first is length)
           rept 4
             db ?
           endm

FHeader1    db 2,10,19,5 ; Commodore 64 Kernal Tape File + version
 FileInfo1 label word
  Type1      db ?         ; type of header
  StartAddr1 dw ?         ; start of program in C64 memory
  StopAddr1  dw ?         ; stop of program in C64 memory
  FileName1 label byte
      rept 10h            ; file name
            db ?
      endm
  FileName1_ label byte
  HeaderData1 label byte
      rept 0BFh-20        ; header data (normaly=20h)
            db ?
      endm
  HeaderData1_ label byte
  ChecksumH1 db ?         ; contain the checksum of 1 header of file
 FileInfo1_ label word
FHeader1_ label word

FHeader2    db 2,10,19,5 ; Commodore 64 Kernal Tape File + version
 FileInfo2 label word
  Type2      db ?         ; type of header
  StartAddr2 dw ?         ; start of program in C64 memory
  StopAddr2  dw ?         ; stop of program in C64 memory
  FileName2 label byte
      rept 10h            ; file name
            db ?
      endm
  FileName2_ label byte
  HeaderData2 label byte
      rept 0BFh-20        ; header data (normaly=20h)
            db ?
      endm
  HeaderData2_ label byte
  ChecksumH2 db ?         ; contain the checksum of 2 header of file
 FileInfo2_ label word
FHeader2_ label word

ProgInfo db 'READER ver 2.00 (C) ICE TEAM inc. 1997-98', 0Dh, 0Ah, '$'
er0      db 'Thanks to have use this program.$'
er1	 db 'No eougth memory: program aborted.$'
erTable  dw offset er0
	 dw offset er1

ilmChoose   equ  0; line for standard info
ilmInput    equ  1; line for input name file
ilmFile     equ  2; line for error in file name
ilmPLoad    equ  3; line for press tape (loading)
ilmStop     equ  4; line for interrupt by ESC key
ilmPath     equ  5; line for path not found
ilmAlready  equ  6; line for file already exists
ilmGeneric  equ  7; line for generic file error
ilmWrong    equ  8; line for wrong type found
ilmNoFile   equ  9; line for no file yet found
ilmChk      equ 10; line for checksum error
ilmNoSave   equ 11; line for no save error
ilmErSave   equ 12; line for save error
ilmExit     equ 13; line for exit but not saved
ilmNotSaved equ 14; line for not saved
ilmNoName   equ 15; line for no name set

ilm0  db 0Fh,'Select highlighted options desired                                  '
ilm1  db 0Fh,'Insert output filename:                                             '
ilm2  db 04h,'ERROR: No name of file is specified (press any key to continue)     '
ilm3  db 0Fh,'Press PLAY on tape (Use ESC key to abort operation)                 '
ilm4  db 04h,'WARNING: Operation interrupt by user (press any key to continue)    '
ilm5  db 04h,'ERROR: Path not found (press any key to continue)                   '
ilm6  db 04h,'WARNING: Output file already exists. Overwrite (Yes/No) ?           '
ilm7  db 04h,'ERROR: Internal DOS error in file creating routine (press any key)  '
ilm8  db 04h,'WARNING: Found an wrong header file. Press Y to continue anyway     '
ilm9  db 04h,'ERROR: Can''t read a file before found it with S option (press a key)'
ilm10 db 04h,'WARNING: Probably read error, save with W option is not raccomanded '
ilm11 db 04h,'ERROR: There''s nothing file to save (press any key to continue)     '
ilm12 db 04h,'ERROR: There''s a problem saving output file (press any key)         '
ilm13 db 04h,'WARNING: File not saved, are you sure to exit (Yes/No) ?            '
ilm14 db 04h,'WARNING: File not saved, continue anyway (Yes/No) ?                 '
ilm15 db 04h,'ERROR: No file name are selected with O option (press any key)      '
InfoLineTable dw offset ilm0
              dw offset ilm1
              dw offset ilm2
              dw offset ilm3
              dw offset ilm4
              dw offset ilm5
              dw offset ilm6
              dw offset ilm7
              dw offset ilm8
              dw offset ilm9
              dw offset ilm10
              dw offset ilm11
              dw offset ilm12
              dw offset ilm13
              dw offset ilm14
              dw offset ilm15


VideoMask label byte
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0
db ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0
db '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4
db '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4
db '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4, '', 4
db '', 4, '', 4, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'b',15, 'y',15, ' ', 0, 'I',15, 'C',15, 'E',15
db ' ', 0, 'T',15, 'E',15, 'A',15, 'M',15, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '', 5, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0
db '', 5, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, '', 5
db ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0, '', 5, '', 5
db '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '6', 2, '4', 2,  16, 2
db  17, 2, 'P', 2, 'C', 2, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'v', 9, 'e', 9, 'r', 9, ' ', 0, '2', 9, '.', 9
db '0', 9, '0', 9, '-', 9, '1', 9, '9', 9, '9', 9, '7', 9, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '',13, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '',13, '',13, '',13, '',13, '',13, ' ', 0, ' ', 0
db '',13, ' ', 0, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, ' ', 0, '',13, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 's', 9, 'h', 9, 'a', 9, 'r', 9, 'e', 9, 'w', 9
db 'a', 9, 'r', 9, 'e', 9, ' ', 9, 's', 9, 'o', 9, 'f', 9, 't', 9
db '.', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'M',15, 'o', 7, 't', 7, 'o', 7, 'r', 7
db ' ', 7, 'O', 7, 'n', 7, '/', 7,'O', 7,  'f', 7, 'f', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'O',15, 'u', 7
db 't', 7, 'p', 7, 'u', 7, 't', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, 'n', 7, 'a', 7, 'm', 7, 'e', 7
db ':', 7, ' ', 7, 'n', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'S',15, 'e', 7, 'a', 7,  'r', 7,'c', 7
db 'h', 7, ' ', 7, 'f', 7, 'o', 7, 'r', 7, ' ', 7, 'f', 7, 'i', 7
db 'l', 7, 'e', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'W',15, 'r', 7
db 'i', 7, 't', 7, 'e', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'R',15, 'e', 7,'a', 7,  'd', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'e', 7, 'X',15
db 'i', 7, 't', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, 'T', 7, 'y', 7, 'p', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'S', 7, 't', 7, 'a', 7, 't', 7
db 'u', 7, 's', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7, 'n', 7
db 'd', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'F', 7, 'i', 7, 'r', 7, 's', 7, 't', 7, ' ', 7
db 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7
db 'n', 7, 'd', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 'r', 7, 'e', 7, 'a', 7, 'd', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'S', 7, 'e', 7, 'c', 7, 'o', 7, 'n', 7, 'd', 7
db ' ', 7, 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'r', 7, 'e', 7, 'a', 7
db 'd', 7, ' ', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 's', 7, 'a', 7, 'v', 7, 'e', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'C', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7, 's', 7
db 'u', 7, 'm', 7, ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'E', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'e', 7, 'r', 7
db 'r', 7, 'o', 7, 'r', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'N', 7, 'a', 7, 'm', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'c', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7
db 's', 7, 'u', 7, 'm', 7, ' ', 7, 'e', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ' ', 7, '1', 7, '-', 7, '2', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'p', 7, 'a', 7, 'r', 7, 'i', 7, 't', 7
db 'y', 7, ' ', 7, 'e', 7, 'r', 7, 'r', 7, 'o', 7, 'r', 7, ' ', 7
db '1', 7, '-', 7, '2', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'm', 7, 'a', 7, 'n', 7, 'c', 7, 'h', 7
db 'e', 7, 's', 7, 't', 7, 'e', 7, 'r', 7, ' ', 7, 'e', 7, 'r', 7
db 'r', 7, 'o', 7, 'r', 7, ' ', 7, '1', 7, '-', 7, '2', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'N', 7, 'u', 7, 'm', 7, 'b', 7, 'e', 7, 'r', 7
db ' ', 7, 'o', 7, 'f', 7, ' ', 7, 'b', 7, 'y', 7, 't', 7, 'e', 7
db ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'l', 7, 'e', 7, 'n', 7, 'g', 7, 't', 7
db 'h', 7, ' ', 7, 'e', 7, 'r', 7, 'r', 7, 'o', 7, 'r', 7, ' ', 7
db '1', 7, '-', 7, '2', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'C', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7, 's', 7
db 'u', 7, 'm', 7, ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 7, ' ', 7, ' ', 7, 's', 7, 't', 7, 'o', 7, 'p', 7, ' ', 7
db 'f', 7, 'o', 7, 'r', 7, 'c', 7, 'e', 7, 'd', 7, ' ', 7, 'b', 7
db 'y', 7, ' ', 7, 'E', 7, 'S', 7, 'C', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9


.CODE

CHANGE_CURSOR_POSITION macro pos
        mov  ah,02h
        mov  bh,0         ; page=0
        mov  dx,pos       ; DH=row DL=col.
        int  10h          ; change cursor position
endm

WRITE_CHAR macro char, attr
        mov  ax,0900h+char
        mov  bx,0000h+attr ; page=0
        mov  cx,1          ; 1 char
        int  10h           ; write one caracter
endm

WRITE_NCHAR macro char, attr, num
        mov  ax,0900h+char
        mov  bx,00+attr   ; page 0 + attrib
        mov  cx,num
        int  10h          ; write cx char
endm

READ_CHAR macro
 @@loop_:
        mov  ah,01
        int  16h
        jz   @@loop_       ; AL=char read if ZF=0

        mov  ah,00
        int  16h           ; AL=char read
endm

LOADING_EFFECT macro sim               ; create loading effect
        pushf
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,Counter               ; get actually video color char position
        mov  al,byte ptr es:[bx]      ; get actually video color
        add  al,16                    ; set to next background color
        and  al,01111111b             ; no intermittence
        mov  byte ptr es:[bx],al
        add  Counter,2                ; set to next position
        cmp  Counter,4001             ; is is over then visible region ?
        jne  @@jump&sim&
        mov  Counter,1                ; yes, set to first position
    @@jump&sim&:
        pop  es
        popf
endm

GET_INT_VECT macro num, vect
        mov  ax,35h*256+num   ; DOS: get int vect
        int  21h
        mov  word ptr[vect],bx
        mov  word ptr[vect+2],es
endm

SET_INT_VECT macro num, vect, par
        push ds
        ifidn <par>,<[]>
             mov  dx,word ptr [vect]
             mov  ax,word ptr [vect+2]
             mov  ds,ax
        else
             mov  dx,offset(vect)
             mov  ax,seg(vect)
             mov  ds,ax
        endif
        mov  ax,25h*256+num   ; DOS: set int vect
        int  21h
        pop  ds
endm

; interrupt routine for the 09h keyboard service
Int09 proc far
        push ds
        push ax
        pushf
        mov  ax,@data
        mov  ds,ax
        cmp  NormalKeyboard,TRUE
        jne  NotNormal
        call Int09Save
        pop  ax
        pop  ds
        iret

  NotNormal:
        in   al,60h             ; read key scan code
        mov  Key,al
        in   al,61h             ; read status
        mov  ah,al
        or   al,80h             ; set reset bit
        out  61h,al             ; out reset bit
        xchg ah,al
        out  61h,al             ; out previous status

        cmp  Key,01h            ; ESC key
        jne  cont

  SetExit:
        mov  StopRead,TRUE

  cont:
        cli
        mov  al,20h
        out  20h,al            ; end of interrupt
        popf
        pop  ax
        pop  ds
        iret
Int09 endp

ReadBit proc                  ; read one bit (carry/zero=bit read)
        mov  dx,IPORT
  @@loop1:
        cmp  StopRead,TRUE
        je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
        cmp  StopRead,TRUE
        je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE1      ; if cx<RATE1 bit=0 else ...
        jbe  @@nothing
        cmp  cx,RATE2      ; if cx<RATE2 bit=1 else bit=*
        jbe  @@Bit1
        inc  ah            ; Z=0 => bit=*
        jmp  @@exit
 @@Bit1:
        inc  ah
 @@nothing:
        xor  al,al         ; Z=1 => bit 0/1
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBit endp

ReadChar proc              ; read one character
        mov  NBit,08h
        mov  CharRead,0
        mov  Parity,0
        call ReadBit
        jnc  @@exit0         ; if bit=1 ok, else end read a block
  @@loop:
        cmp  StopRead,TRUE
        je   @@exit
        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jc   @@WaitFor0      ; if bit=1 then wait for a 0 bit
        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jnc  @@Manc_Error    ; if bit=0 we have 00 => error
        LOADING_EFFECT 1
        clc                  ; we have a '0' bit
        jmp @@SetBit
   @@WaitFor0:
        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jc   @@Manc_Error    ; if bit=1 we have 11 => error
        LOADING_EFFECT 2
        stc
  @@SetBit:
        pushf
        rcr  CharRead,1
        popf
        adc  Parity,0
        dec  NBit
        jnz  @@loop

        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jc   @@WaitFor0_     ; if bit=1 then wait for a 0 bit
        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jnc  @@Manc_Error    ; if bit=0 we have 00 => error
        LOADING_EFFECT 3
        clc                  ; we have a '0' bit
        jmp @@SetBit_
  @@WaitFor0_:
        call ReadBit
        jnz  @@BitError      ; if bit=* error
        jc   @@Manc_Error    ; if bit=1 we have 11 => error
        LOADING_EFFECT 4
        stc
  @@SetBit_:
        adc  Parity,0        ; Parity will be odd for correnct char
        test Parity,01h
        jnz  @@NotParityError
        inc  ParityError     ; there's another parity error
  @@NotParityError:
        mov  al,CharRead     ; return the char read in al
        clc                  ; operation ok
  @@exit:
        ret

  @@Manc_Error:
        inc  ManchesterError ; there's another code error
        clc                  ; assume that the bit was '0'
        jmp  @@SetBit

  @@BitError:
        stc                  ; operation aboart
        mov  Mode,stFOUND_SEP
        ret
  @@exit0:
        stc                  ; operation aboart
        mov  Mode,stEND_READ
        ret
ReadChar endp

FIND_SYNC macro H, num
  @@SearchSep&H&:
        mov  ManchesterError,0
        mov  ParityError,0

        cmp  StopRead,TRUE
        je   @@exit
                              ; now try to find 89..81/09..01 sequence
        mov  Count,num
  @@sequence&H&:
        cmp  StopRead,TRUE
        je   @@exit
        call ReadBit
        jz   @@sequence&H&    ; Z=1 => bit 0/1

        call ReadChar         ; AL=byte read
        cmp  al,Count
        jne  @@SearchSep&H&   ; if different => try syncronization again
        dec  Count
        cmp  Count,num-9
        jne  @@sequence&H&
endm

READ_HEADER macro H, Buffer
        mov  bx,ds            ; the information must be saved in a buffer
        mov  es,bx
        mov  di,offset Buffer ; DI point at the beginning of buffer
        mov  si,1             ; SI contain the readed byte (in a header $BF bytes)

        stosb                 ; store the type of header
  @@loop&H&:
        cmp  StopRead,TRUE
        je   @@exit
        call ReadBit
        jz   @@end_reading_&H&   ; Z=1 => bit 0/1
        call ReadChar            ; AL=byte read
        jc   @@end_reading_&H&
        stosb                    ; store the byte read
        xor  Chk&H&,al           ; calculate checksum
        inc  si                  ; another byte read
        cmp  si,0C0h
        je   @@end_reading&H&
        jmp  @@loop&H&
  @@end_reading&H&:              ; now read the checksum of header
        call ReadBit
        jz   @@end_reading_&H&   ; Z=1 => bit 0/1
        call ReadChar            ; al=byte read
        mov  Checksum&H&,al      ; save checksum
        stosb

  @@end_reading_&H&:
endm

READ_FILE macro F, num
        mov  bx,SegBuffer&num&
        mov  es,bx
        xor  di,di               ; position at the start of memory
        xor  si,si               ; SI contain the effective byte reads
        mov  Chk&F&,0            ; initialize Checksum
  @@loop&F&:
        cmp  StopRead,TRUE
        je   @@exit
        call ReadBit
        jz   @@end_reading_&F&   ; Z=1 => bit 0/1
        call ReadChar            ; AL=byte read
        jc   @@end_reading_&F&
        stosb                    ; store the byte read
        xor  Chk&F&,al           ; calculate checksum
        inc  si                  ; another byte read
        cmp  si,FileLength&num&
        jae  @@end_reading&F&
        jmp  @@loop&F&
  @@end_reading&F&:
        call ReadBit
        jz   @@end_reading_&F&   ; Z=1 => bit 0/1
        call ReadChar            ; al=byte read
        mov  Checksum&F&,al      ; save checksum
        stosb                    ; store the checksum
  @@end_reading_&F&:
endm

ReadHeader proc               ; read header of a file
                              ; try to find a valid syncronization
        FIND_SYNC H1, 89h
                              ; try to find a valid header (01,03,04)
        call ReadBit
        jz   @@SearchSepH1    ; Z=1 => bit 0/1
        call ReadChar         ; AL=byte read
        mov  ChkH1,al         ; initialize chechsum for header 1
        cmp  al,01h
        je   @@Read
        cmp  al,03h
        je   @@Read
        cmp  al,04h
        je   @@Read
        jmp  @@SearchSepH1
  @@Read:
                               ; read the header block
        READ_HEADER H1, FileInfo1

        cmp  Mode,stFOUND_SEP
        je   @@SearchSepH1
                              ; store the number of errors appearse in header1
        mov  al,ParityError
        mov  ParityErrorH1,al
        mov  al,ManchesterError
        mov  ManchesterErrorH1,al
        mov  EffectiveReadH1,si
                              ; try to find a valid syncronization
        FIND_SYNC  H2, 09h
                              ; try to find a valid header (01,03,04)
        call ReadBit
        jz   @@SearchSepH1    ; Z=1 => bit 0/1
        call ReadChar         ; AL=byte read
        mov  ChkH2,al         ; initialize checksum for header 2
        cmp  al,01h
        je   @@Read2
        cmp  al,03h
        je   @@Read2
        cmp  al,04h
        je   @@Read2
        jmp  @@SearchSepH2
  @@Read2:
                              ; read the header block
        READ_HEADER H2, FileInfo2

        cmp  Mode,stFOUND_SEP
        je   @@SearchSepH2
                              ; store the number of errors appearse in header2
        mov  al,ParityError
        mov  ParityErrorH2,al
        mov  al,ManchesterError
        mov  ManchesterErrorH2,al
        mov  EffectiveReadH2,si
  @@exit:
        ret
ReadHeader endp

ReadFile proc              ; read the file block
                                  ; try to find a valid syncronization
        FIND_SYNC F1, 89h
                                  ; read the effective buffer
        READ_FILE F1, 1

        mov  al,ParityError
        mov  ParityErrorF1,al
        mov  al,ManchesterError
        mov  ManchesterErrorF1,al
        mov  EffectiveReadF1,si
                                  ; try to find a valid syncronization
        FIND_SYNC F2, 09h
                                  ; read the effective buffer
        READ_FILE F2, 2

        mov  al,ParityError
        mov  ParityErrorF2,al
        mov  al,ManchesterError
        mov  ManchesterErrorF2,al
        mov  EffectiveReadF2,si

  @@toolong:
  @@exit:
        ret
ReadFile endp

SaveHeader proc            ; save the header of the file (DX=segment)
        mov  bx,FHandle
        mov  cx,offset(FHeader1_)-offset(FHeader1)
        mov  ah,40h
        int  21h              ; write cx byte from ds:dx
        ret
SaveHeader endp

SaveFile proc              ; save the file data (AX=segment, CX=byte)
        mov  bx,FHandle
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h              ; write cx byte from ds:dx
        pop  ds
        ret
SaveFile endp

CloseFile proc             ; close a file
         mov  ah,3Eh
         mov  bx,FHandle
         int  21h             ; file close
         ret
CloseFile endp

ExitProc proc              ; write exit message and exit from program
        mov  cl,al
        call InitScreen
        mov  dx,offset ProgInfo
        mov  ah,09h
        int  21h               ; write program information
        mov  bl,cl
        xor  bh,bh
        add  bl,bl
        mov  dx,[bx+offset erTable]
        mov  ah,09h
        int  21h               ; write exit message
        mov  al,cl
        mov  ah,4Ch
        int  21h               ; terminate with return code
        ret
ExitProc endp

MotorOn proc              ; on the cassette motor

        mov  MotorFlag,TRUE

        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 0Fh          ; 'O', attrib.=15
        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=14
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOn endp

MotorOff proc             ; off the cassette motor

        mov  MotorFlag,FALSE

        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=13
        WRITE_CHAR 4Fh 0Fh           ; 'O', attrib=15
        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOff endp

OpenFile proc             ; create a new file
        mov  ax,5B02h
        xor  cx,cx                    ; write only
        mov  dx,offset(InputBuffer+2) ; asciiz name
        int  21h                      ; create new file
        jc   @@error
  @@ok:
        mov  FHandle,ax               ; store file handle
        clc                           ; file ok
        ret
  @@error:
        cmp  ax,50h                   ; file already exists error
        je   @@already
  @@error2:
        cmp  ax,03h                   ; path not found error
        je   @@path
        mov  bl,ilmGeneric
        call WriteInfoLine            ; line for generic file error
        jmp  @@exit_
  @@already:
        mov  bl,ilmAlready
        call WriteInfoLine            ; line for file already exists
  @@loop:
        mov  ah,01
        int  16h
        jz   @@loop        ; AL=char read if ZF=0
        mov  ah,00
        int  16h           ; AL=char read

        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   @@rewrite
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        je   @@exit
  @@rewrite:
        mov  ax,3C02h
        mov  dx,offset(InputBuffer+2) ; asciiz name
        xor  cx,cx
        int  21h                      ; create a file
        jc   @@error2
        jmp  @@ok

  @@path:
        mov  bl,ilmPath
        call WriteInfoLine            ; line for path not found
  @@exit_:
        READ_CHAR
  @@exit:
        stc                           ; file error
        ret
OpenFile endp

SaveCopy2 proc          ; save the copy 2 of file without see for error
        mov  dx,offset(Copy2name)
        xor  cx,cx                  ; write only
        mov  ah,3Ch
        int  21h                    ; create a new file
        mov  FHandle,ax
        mov  dx,offset(FHeader2)
        mov  cx,offset(FHeader2_)-offset(FHeader2)
        call SaveHeader
        mov  ax,SegBuffer2
        mov  cx,FileLength2
        inc  cx                     ; there's a checksum too
        call SaveFile               ; save the file
        call CloseFile
        ret
SaveCopy2 endp

InitScreen proc
        mov  ax,03h            ; Standard Mode
        int  10h
        ret
InitScreen endp

WriteVideoMask proc        ; write the video mask
       mov  ax,VIDEO_SEG
       mov  es,ax
       xor  di,di
       mov  si,offset(VideoMask)
       mov  cx,25*80
       rep  movsw
       ret
WriteVideoMask endp

WriteInfoLine proc        ; write message into info line (BL set message)
        mov  dx,1702h     ; row=24 col.=3
        xor  bh,bh        ; page =0
        add  bl,bl        ; bl=number of infomessage
        mov  bp,[bx+offset InfoLineTable]
        mov  bl,ds:[bp]   ; attrib.
        inc  bp
        mov  ax,@data
        mov  es,ax        ; ES:BP=string
        mov  ax,1300h
        mov  cx,68        ; string length
        int  10h          ; write infoline message
        ret
WriteInfoLine endp

HideCursor proc           ; make the cursor invisible
       mov  ah,03
       xor  bh,bh         ; page 0
       int  10h           ; info about corsor
       mov  CursorForm,cx ; form of the cursor

       mov  ah,01h
       mov  ch,20h        ; invisible cursor
       int  10h           ; set cursor form
       ret
HideCursor endp

ShowCursor proc           ; make the cursor visible
       mov  ah,01h
       mov  cx,CursorForm
       int  10h           ; set form of the cursor as normal
       ret
ShowCursor endp

InputName proc            ; read input file name by keyboard

        CHANGE_CURSOR_POSITION 171Ah  ; row=24 col.=27
        mov  ah,0Ah
        mov  dx,offset(InputBuffer)
        int  21h          ; input a string
        ret
InputName endp

StringCopy proc           ; copy one string (ds:si) in another (es:di)
        sub  dx,bx
        cmp  ax,bx
        jb   lower
        mov  ax,bx
  lower:
        stosb             ; save length
        mov  cx,ax
        add  bx,si
        rep  movsb        ; copy string
        mov  si,bx
        ret
StringCopy endp

SplitName proc            ; split file name component
        mov  ax,@data
        mov  es,ax
        cld
        mov  si,offset(InputBuffer+1)
        lodsb             ; al=length of input name string
        mov  dl,al
        xor  dh,dh        ; dx=length
        mov  bx,dx
        or   bx,bx        ; ?=0
        je   zero
  @@loop:
        cmp  byte ptr [bx+si-1],'\'
        je   zero
        cmp  byte ptr [bx+si-1],':'
        je   zero
        dec  bx
        jne  @@loop
  zero:
        mov  ax,28        ; max path length
        mov  di,offset(FPath)
        call StringCopy
        xor  bx,bx
        jmp  for_name
  continue:
        cmp  byte ptr [bx+si],'.'
        je   name_found
        inc  bx
  for_name:
        cmp  bx,dx
        jne  continue
  name_found:
        mov  ax,08
        mov  di,offset(FName)
        call StringCopy
        mov  bx,dx
        mov  ax,0004
        mov  di,offset(FExtension)
        call StringCopy
        ret
SplitName endp

UpdateFileName proc       ; write actul file name into his line
        CHANGE_CURSOR_POSITION 0642h ; row=7 col.=67
        mov  si,offset(FName+1)
        mov  cl,byte ptr [FName] ; length of name
        xor  ch,ch
        cld
  @@loop:
        lodsb
        cmp  al,'a'
        jb   @@not
        cmp  al,'z'
        ja   @@not
        and  al,11011111b  ; make char upper
  @@not:
        mov  ah,0Eh
        xor  bh,bh        ; page=0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop

        mov  si,offset(FExtension+1)
        mov  cl,byte ptr [FExtension] ; length of extension
  @@loop1:
        lodsb
        cmp  al,'a'
        jb   @@not1
        cmp  al,'z'
        ja   @@not1
        and  al,11011111b  ; make char upper
  @@not1:
        mov  ah,0Eh
        mov  bh,00;07h    ; page=0 color=7
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop1
                          ; calculate if name<max name
        mov  cl,byte ptr [FName]
        add  cl,byte ptr [FExtension]
        mov  ch,12
        sub  ch,cl
        jz   @@exit      ; if not equal we must delete the extra
        mov  cl,ch
        xor  ch,ch
  @@loop2:
        mov  ax,0E20h
        mov  bh,00        ; page 0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop2
  @@exit:
        ret
UpdateFileName endp

WriteNumInfo1 proc         ; write numeric string info
        mov  dl,11h                   ; col=dl
        mov  ax,1300h
        mov  bx,000Fh                 ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,byte ptr [TempBuffer] ; string length
        mov  bp,offset(TempBuffer+1)
        int  10h                      ; write string es:bp
        ret
WriteNumInfo1 endp

WriteNumInfo2 proc         ; write numeric string info
        mov  dl,22h                   ; col=dl
        mov  ax,1300h
        mov  bx,000Fh                 ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,byte ptr [TempBuffer] ; string length
        mov  bp,offset(TempBuffer+1)
        int  10h                      ; write string es:bp
        ret
WriteNumInfo2 endp

WriteNumInfo proc         ; write numeric string info
        push es
        mov  ax,ds
        mov  es,ax
        mov  ax,1300h
        mov  bx,000Fh                 ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,byte ptr [TempBuffer] ; string length
        mov  bp,offset(TempBuffer+1)
        int  10h                      ; write string es:bp
        pop  es
        ret
WriteNumInfo endp

WriteFileInfo proc        ; write info about header of tape file to video
        mov  ax,@data
        mov  es,ax                ; es used byte int 10h

        mov  al,Type1
        call HexByte              ; convert hex byte to string
        mov  dh,0Dh               ; row
        call WriteNumInfo1        ; write numeric string info 1

        mov  al,Type2
        call HexByte              ; convert hex byte to string
        call WriteNumInfo2        ; write numeric string info 2

        mov  ax,StartAddr1
        call HexWord              ; convert hex word to string
        mov  dh,0Eh               ; row
        call WriteNumInfo1        ; write numeric string info 1

        mov  ax,StartAddr2
        call HexWord              ; convert hex word to string
        call WriteNumInfo2        ; write numeric string info 2

        mov  ax,StopAddr1
        call HexWord              ; convert hex word to string
        mov  dh,0Fh               ; row
        call WriteNumInfo1        ; write numeric string info 1

        mov  ax,StopAddr2
        call HexWord              ; convert hex word to string
        call WriteNumInfo2        ; write numeric string info 2

        mov  al,CheckSumH1
        call HexByte              ; convert hex byte to string
        mov  dh,10h               ; row
        call WriteNumInfo1        ; write numeric string info 1

        mov  al,CheckSumH2
        call HexByte              ; convert hex byte to string
        mov  dh,10h               ; row
        call WriteNumInfo2        ; write numeric string info 2

        mov  dx,1111h             ; row/col.
        mov  ax,1300h
        mov  bx,000Fh             ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,16                ; string length
        mov  bp,offset(FileName1)
        int  10h                  ; write string es:bp

        mov  dx,1122h             ; row/col.
        mov  ax,1300h
        mov  bx,000Fh             ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,16                ; string length
        mov  bp,offset(FileName2)
        int  10h                  ; write string es:bp
                                  ; calculate file length
        mov  ax,StopAddr1
        mov  bx,StartAddr1
        sub  ax,bx
        mov  FileLength1,ax       ; store file length 1
        mov  ax,StopAddr2
        mov  bx,StartAddr2
        sub  ax,bx
        mov  FileLength2,ax      ; store file length 2

        ret
WriteFileInfo endp

WriteFileData proc        ; write info about data part of tape file to video
        mov  ax,@data
        mov  es,ax          ; es used byte int 10h

        mov  ax,FileLength1
        call HexWord        ; convert hex word to string
        mov  dh,14h
        call WriteNumInfo1  ; write numeric string info 1

        mov  ax,FileLength2
        call HexWord        ; convert hex word to string
        call WriteNumInfo2  ; write numeric string info 2

        mov  al,ChecksumF1
        call HexByte        ; convert hex byte to string
        mov  dh,15h         ; row
        call WriteNumInfo1  ; write numeric string info 1

        mov  al,ChecksumF2
        call HexByte        ; convert hex byte to string
        call WriteNumInfo2  ; write numeric string info 2
        ret
WriteFileData endp

WriteSpace proc             ; erase video file information
        CHANGE_CURSOR_POSITION 0D11h
        WRITE_NCHAR ' ', 0Fh, 19         ; line for type1
        CHANGE_CURSOR_POSITION 0E11h
        WRITE_NCHAR ' ', 0Fh, 21         ; line for start addrs
        CHANGE_CURSOR_POSITION 0F11h
        WRITE_NCHAR ' ', 0Fh, 21         ; line for stop addrs
        CHANGE_CURSOR_POSITION 1011h
        WRITE_NCHAR ' ', 0Fh, 21         ; line for checksum
        CHANGE_CURSOR_POSITION 1111h
        WRITE_NCHAR ' ', 0Fh, 34         ; line for name
        CHANGE_CURSOR_POSITION 1411h
        WRITE_NCHAR ' ', 0Fh, 21         ; line for number of byte
        CHANGE_CURSOR_POSITION 1511h
        WRITE_NCHAR ' ', 0Fh, 19         ; line for chksum
        ret
WriteSpace endp

HexByte proc              ; convert hex byte to string
        mov  byte ptr [TempBuffer],2
        xor  bh,bh
        mov  bl,al                      ; al=hex
        shr  bl,4                       ; hi nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ah
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ah
        ret
HexByte endp

HexWord proc              ; convert hex word to string
        mov  byte ptr [TempBuffer],4    ; string length
        xor  bh,bh
        mov  bl,ah
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ch
        mov  bl,ah
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ch
        mov  bl,al
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+3],ch
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+4],ch
        ret
HexWord endp

ChangeError proc          ; change color of error line
        mov  ax,VIDEO_SEG
        mov  es,ax

        mov  dl,Error
        cmp  dl,erNormal
        jne  @@exit
                          ; set all attribute to 07h
        mov  di,16*80*2+51*2+1  ; line of no error
        mov  cx,001Bh
        mov  bl,07h
  @@loop_1:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_1

        mov  di,17*80*2+51*2+1  ; line of checksum error
        mov  cx,001Bh
  @@loop_2:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_2

        mov  di,18*80*2+51*2+1  ; line of parity error
        mov  cx,001Bh
  @@loop_3:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_3

        mov  di,19*80*2+51*2+1  ; line of manchester error
        mov  cx,001Bh
  @@loop_4:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_4

        mov  di,20*80*2+51*2+1  ; line of length error
        mov  cx,001Bh
  @@loop_5:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_5

        mov  di,21*80*2+51*2+1  ; line of stop forced by esc
        mov  cx,001Bh
  @@loop_6:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_6
        CHANGE_CURSOR_POSITION 1248h
        WRITE_NCHAR ' ', 0Fh, 6          ; parity error number
        CHANGE_CURSOR_POSITION 1348h
        WRITE_NCHAR ' ', 0Fh, 6          ; checksum error number

  @@exit:
        ret
ChangeError endp

ChangeErrorH proc          ; change color of error line
        mov  ax,VIDEO_SEG
        mov  es,ax
                          ; set all attribute to 07h
        mov  di,16*80*2+51*2+1  ; line of no error
        mov  cx,001Bh
        mov  bl,07h
  @@loop_1:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_1

        mov  di,17*80*2+51*2+1  ; line of checksum error
        mov  cx,001Bh
  @@loop_2:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_2

        mov  di,18*80*2+51*2+1  ; line of parity error
        mov  cx,001Bh
  @@loop_3:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_3

        mov  di,19*80*2+51*2+1  ; line of manchester error
        mov  cx,001Bh
  @@loop_4:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_4

        mov  di,20*80*2+51*2+1  ; line of length error
        mov  cx,001Bh
  @@loop_5:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_5

        mov  di,21*80*2+51*2+1  ; line of stop forced by esc
        mov  cx,001Bh
  @@loop_6:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_6
        CHANGE_CURSOR_POSITION 1248h
        WRITE_NCHAR ' ', 0Fh, 6          ; parity error number
        CHANGE_CURSOR_POSITION 1348h
        WRITE_NCHAR ' ', 0Fh, 6          ; checksum error number

  @@er1:
        mov  bl,0Fh
        test Error,er1line      ; line of no error
        jz   @@er2
        mov  di,16*80*2+51*2+1  ; line of no error
        mov  cx,001Bh
  @@loop1:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop1

  @@er2:
        test Error,er2line      ; line of checksum error
        jz   @@er3
        mov  di,17*80*2+51*2+1  ; line of checksum error
        mov  cx,000Eh
  @@loop2:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop2

        mov  al,ChecksumH1
        xor  al,ChkH1
        je   @@CEH2
        mov  di,17*80*2+66*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ChecksumH2
        xor  al,ChkH2
        je   @@er3
  @@CEH2:
        mov  di,17*80*2+68*2+1  ; char '2'
        mov  es:di,bl

  @@er3:
        test Error,er3line      ; line of parity error
        jz   @@er4
        mov  di,18*80*2+51*2+1  ; line of parity error
        mov  cx,000Dh
  @@loop3:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop3
        cmp  ParityErrorH1,0
        je   @@PEH2
        mov  di,18*80*2+64*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ParityErrorH1
        call HexByte
        mov  dx,1248h           ; row/col
        call WriteNumInfo
        mov  bl,0Fh

        cmp  ParityErrorH2,0
        je   @@er4
  @@PEH2:
        mov  di,18*80*2+66*2+1  ; char '2'
        mov  es:di,bl
        mov  al,ParityErrorH2
        call HexByte
        mov  dx,124Ch           ; row/col
        call WriteNumInfo
        mov  bl,0Fh

  @@er4:
        test Error,er4line      ; line of manchester error
        jz   @@er5
        mov  di,19*80*2+51*2+1  ; line of manchester error
        mov  cx,0010h
  @@loop4:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop4

        cmp  ManchesterErrorH1,0
        je   @@MEH2
        mov  di,19*80*2+68*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ManchesterErrorH1
        call HexByte
        mov  dx,1348h           ; row/col
        call WriteNumInfo
        mov  bl,0Fh
        cmp  ManchesterErrorH2,0
        je   @@er5
  @@MEH2:
        mov  di,19*80*2+70*2+1  ; char '2'
        mov  es:di,bl
        mov  al,ManchesterErrorH2
        call HexByte
        mov  dx,134Ch           ; row/col
        call WriteNumInfo
        mov  bl,0Fh

  @@er5:
        test Error,er5line      ; line of length error
        jz   @@er6
        mov  di,20*80*2+51*2+1  ; line of length error
        mov  cx,000Ch
  @@loop5:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop5
        cmp  EffectiveReadH1,0C0h
        je   @@LEH2
        mov  di,20*80*2+64*2+1  ; char '1'
        mov  es:di,bl
        cmp  EffectiveReadH2,0C0h
        je   @@er6
  @@LEH2:
        mov  di,20*80*2+66*2+1  ; char '2'
        mov  es:di,bl

  @@er6:
        test Error,er6line      ; line of stop forced by esc
        jz   @@exit
        mov  di,21*80*2+51*2+1  ; line of stop forced by esc
        mov  cx,001Ah
  @@loop6:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop6

  @@exit:
        ret
ChangeErrorH endp

ChangeErrorF proc          ; change color of error line
        mov  ax,VIDEO_SEG
        mov  es,ax
                          ; set all attribute to 07h
        mov  di,16*80*2+51*2+1  ; line of no error
        mov  cx,001Bh
        mov  bl,07h
  @@loop_1:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_1

        mov  di,17*80*2+51*2+1  ; line of checksum error
        mov  cx,001Bh
  @@loop_2:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_2

        mov  di,18*80*2+51*2+1  ; line of parity error
        mov  cx,001Bh
  @@loop_3:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_3

        mov  di,19*80*2+51*2+1  ; line of manchester error
        mov  cx,001Bh
  @@loop_4:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_4

        mov  di,20*80*2+51*2+1  ; line of length error
        mov  cx,001Bh
  @@loop_5:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_5

        mov  di,21*80*2+51*2+1  ; line of stop forced by esc
        mov  cx,001Bh
  @@loop_6:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop_6
        CHANGE_CURSOR_POSITION 1248h
        WRITE_NCHAR ' ', 0Fh, 6          ; parity error number
        CHANGE_CURSOR_POSITION 1348h
        WRITE_NCHAR ' ', 0Fh, 6          ; checksum error number

  @@er1:
        mov  bl,0Fh
        test Error,er1line      ; line of no error
        jz   @@er2
        mov  di,16*80*2+51*2+1  ; line of no error
        mov  cx,001Bh
  @@loop1:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop1

  @@er2:
        test Error,er2line      ; line of checksum error
        jz   @@er3
        mov  di,17*80*2+51*2+1  ; line of checksum error
        mov  cx,000Eh
  @@loop2:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop2

        mov  al,ChecksumF1
        xor  al,ChkF1
        je   @@CEF2
        mov  di,17*80*2+66*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ChecksumF2
        xor  al,ChkF2
        je   @@er3
  @@CEF2:
        mov  di,17*80*2+68*2+1  ; char '2'
        mov  es:di,bl

  @@er3:
        test Error,er3line      ; line of parity error
        jz   @@er4
        mov  di,18*80*2+51*2+1  ; line of parity error
        mov  cx,000Dh
  @@loop3:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop3
        cmp  ParityErrorF1,0
        je   @@PEF2
        mov  di,18*80*2+64*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ParityErrorF1
        call HexByte
        mov  dx,1248h           ; row/col
        call WriteNumInfo
        mov  bl,0Fh
        cmp  ParityErrorF2,0
        je   @@er4
  @@PEF2:
        mov  di,18*80*2+66*2+1  ; char '2'
        mov  es:di,bl
        mov  al,ParityErrorF2
        call HexByte
        mov  dx,124Ch           ; row/col
        call WriteNumInfo
        mov  bl,0Fh


  @@er4:
        test Error,er4line      ; line of manchester error
        jz   @@er5
        mov  di,19*80*2+51*2+1  ; line of manchester error
        mov  cx,0010h
  @@loop4:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop4

        cmp  ManchesterErrorF1,0
        je   @@MEF2
        mov  di,19*80*2+68*2+1  ; char '1'
        mov  es:di,bl
        mov  al,ManchesterErrorF1
        call HexByte
        mov  dx,1348h           ; row/col
        call WriteNumInfo
        mov  bl,0Fh
        cmp  ManchesterErrorF2,0
        je   @@er5
  @@MEF2:
        mov  di,19*80*2+70*2+1  ; char '2'
        mov  es:di,bl
        mov  al,ManchesterErrorF2
        call HexByte
        mov  dx,134Ch           ; row/col
        call WriteNumInfo
        mov  bl,0Fh

  @@er5:
        test Error,er5line      ; line of length error
        jz   @@er6
        mov  di,20*80*2+51*2+1  ; line of length error
        mov  cx,000Ch
  @@loop5:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop5
        mov  ax,FileLength1
        cmp  ax,EffectiveReadF1
        je   @@LEF2
        mov  di,20*80*2+64*2+1  ; char '1'
        mov  es:di,bl
        mov  ax,FileLength2
        cmp  ax,EffectiveReadF2
        je   @@er6
  @@LEF2:
        mov  di,20*80*2+66*2+1  ; char '2'
        mov  es:di,bl

  @@er6:
        test error,er6line      ; line of stop forced by esc
        jz   @@exit
        mov  di,21*80*2+51*2+1  ; line of stop forced by esc
        mov  cx,001Ah
  @@loop6:
        mov  es:di,bl           ; change attribute
        add  di,2
        loopne @@loop6

  @@exit:
        ret
ChangeErrorF endp

ChangeStatus proc         ; change color of status line
        mov  dl,Status
        cmp  dl,stNormal  ; line of normal
        je   @@Normal
        cmp  dl,st1line   ; line of no file found
        je   stline1
        cmp  dl,st2line   ; line of one file found (not read)
        je   stline2
        mov  bx,0707h     ; 1=07, 2=07, 3=0F color
        mov  dh,0Fh
        jmp  modify
  @@Normal:
        mov  bx,0707h     ; 1=07, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline1:
        mov  bx,0F07h     ; 1=0F, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline2:
        mov  bx,070Fh     ; 1=0F, 2=0F, 3=07 color
        mov  dh,07h
  modify:
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  di,13*80*2+51*2+1  ; line of no file found
        mov  cx,001Ah
  @@loop:
        mov  es:di,bh
        add  di,2
        loopne @@loop
        mov  di,14*80*2+51*2+1  ; line of one file found (not read)
        mov  cx,001Ah
  @@loop1:
        mov  es:di,bl
        add  di,2
        loopne @@loop1
        mov  di,15*80*2+51*2+1  ; line of one file read (not save)
        mov  cx,001Ah
  @@loop2:
        mov  es:di,dh
        add  di,2
        loopne @@loop2
        ret
ChangeStatus endp

RestoreAttribute proc          ; restore black attribute to video
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,1
        mov  cx,2000           ; all video memory
  @@loop:
        mov  al,es:[bx]
        and  al,00001111b      ; set background=black
        mov  es:[bx],al
        add  bx,2
        loopnz @@loop
        pop  es
        mov  Counter,1         ; set to start of attributes
        ret
RestoreAttribute endp

SET_ERROR macro H
        mov  al,Chk&H&1
        xor  al,Checksum&H&1
        jz   @@ChkFor&H&2
        or   Error,er2Line        ; there's a checksum error

  @@ChkFor&H&2:
        mov  al,Chk&H&2
        xor  al,Checksum&H&2
        jz   @@Parity&H&1
        or   Error,er2Line        ; there's a checksum error
  @@Parity&H&1:
        cmp  ParityError&H&1,0
        jz   @@Parity&H&2
        or   Error,er3Line        ; there's a parity error
  @@Parity&H&2:
        cmp  ParityError&H&2,0
        jz   @@Manch&H&1
        or   Error,er3Line        ; there's a parity error
  @@Manch&H&1:
        cmp  ManchesterError&H&1,0
        jz   @@Manch&H&2
        or   Error,er4Line        ; there's a manchester error
  @@Manch&H&2:
        cmp  ManchesterError&H&2,0
        jz   @@Length&H&1
        or   Error,er4Line        ; there's a manchester error
 ifidn <H>,<F>
  @@Length&H&1:
        mov  ax,FileLength1
        cmp  ax,EffectiveReadF1
        jz   @@Length&H&2
        or   Error,er5Line        ; there's a length error
  @@Length&H&2:
        mov  ax,FileLength2
        cmp  ax,EffectiveReadF2
        jz   @@cont
        or   Error,er5Line        ; there's a length error
 else
   @@Length&H&1:
        cmp  EffectiveReadH1,0C0h
        jz   @@Length&H&2
        or   Error,er5Line        ; there's a length error
  @@Length&H&2:
        cmp  EffectiveReadH2,0C0h
        jz   @@cont
        or   Error,er5Line        ; there's a length error
 endif
  @@Cont:
        cmp  Error,er1Line
        jb   @@Not
        and  Error,not(er1Line)   ; erase line of no error
  @@not:
endm

prova proc
        xor si,si
        xor di,di
  @@SearchSep:
        mov  ManchesterError,0
        mov  ParityError,0

        cmp  StopRead,TRUE
        je   @@exit

        mov  bx,SegBuffer1   ; the information must be saved in a buffer
        mov  es,bx
  @@loop&H&:
        call ReadBit
        jz   @@SearchSep   ; Z=1 => bit 0/1

        cmp  StopRead,TRUE
        je   @@exit
        call ReadChar         ; AL=byte read
        jc   @@end_reading&H&
        stosb                 ; store the byte read
        inc  si               ; another byte read
        jmp  @@loop&H&
  @@end_reading&H&:
        jmp @@SearchSep
  @@exit:
      ret
prova endp

Main:
                            ; set up stack and reduce memory allocation
        lea  bx,EndStack
        mov  cl,4
        shr  bx,cl          ; adjust to program
        inc  bx             ; round up
        mov  ax,ss
        add  bx,ax
        mov  ax,ds
        sub  bx,ax
        mov  ah,4Ah
        int  21h            ; change memory allocation

        mov  ax,@data
        mov  ds,ax

        mov  ah,48h
        mov  bx,4096
        int  21h                      ; get 64K dos memory
        jnc  @@noerror

        mov  al,01h                   ; terminate with 01 error code
        call ExitProc

  @@noerror:
        mov  SegBuffer1,ax            ; store segment of buffer

        mov  ah,48h
        mov  bx,4096
        int  21h                      ; get 64K dos memory
        jnc  @@noerror2

        mov  al,01h                   ; terminate with 01 error code
        call ExitProc

  @@noerror2:
        mov  SegBuffer2,ax            ; store segment of buffer

        call InitScreen
        mov  NormalKeyboard,TRUE
	GET_INT_VECT 09h, Int09Save
        SET_INT_VECT 09h, Int09       ; insert int 09 handler

        call WriteVideoMask   ; write video mask page
        call HideCursor       ; make the cursor invisible
        call MotorOff
  loop_:
        mov  bl,ilmChoose
        call WriteInfoLine ; line for standard info
        call ChangeError   ; change error with actual error code
  loop__:
        READ_CHAR
        and  al,11011111b  ; make char upper

        cmp  al,'X'        ; exit from program
        je   exit

        cmp  al,'M'        ; motor on/off
        je   motor

        cmp  al,'S'        ; find a file from tape
        je   find

        cmp  al,'R'        ; read a file from tape
        je   read

        cmp  al,'O'        ; output filename
        je   output

        cmp  al,'W'        ; write file in PC format
        je   write

        jmp  loop__

  motor:
        cmp  MotorFlag,TRUE
        je   motor_off
        call MotorOn                ; make motor on
        jmp  loop_
  motor_off:
        call MotorOff               ; make motor off
        jmp  loop_

  find:
        cmp  Status,st3Line         ; is file read but not saved ?
        jne  find_
        mov  bl,ilmNotSaved
        call WriteInfoLine
        READ_CHAR
        and  al,11011111b           ; make char upper
        cmp  al,'Y'
        je   find_
        jmp  loop_

  find_:
        call WriteSpace             ; erase old video file information
        call MotorOn                ; make motor on
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
        mov  Status,st1Line        
        call ChangeStatus           ; line of no file found
        mov  Error,er1Line
        call ChangeErrorH           ; line of no error
        mov  NormalKeyboard,FALSE
  @@loop:
        call ReadHeader             ; try to read an file header
        cmp  StopRead,TRUE          ; if interrupt by ESC key
        je   error_ilmStop          ; go error message

        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  NormalKeyboard,TRUE
        mov  Status,st2Line
        call ChangeStatus           ; line of one file found (not read)
        call WriteFileInfo          ; write info about file

        SET_ERROR H                 ; set the lines if there's errors
        call ChangeErrorH
        jmp  loop_

  error_ilmStop:
        call RestoreAttribute
        mov  bl,ilmStop
        call WriteInfoLine          ; line for interrupt by ESC key
        mov  Status,stNormal
        call ChangeStatus           ; line for normal status
        mov  Error,er6Line
        call ChangeErrorH           ; line for stop by esc
        mov  Error,erNormal
        mov  NormalKeyboard,TRUE
        mov  StopRead,FALSE
        call MotorOff               ; make motor off
        READ_CHAR
        jmp  loop_
  read:
        cmp  Status,st2Line         ; there's a file found ?
        jz   @@read
        mov  bl,ilmNoFile
        call WriteInfoLine          ; line for no file yet found
        READ_CHAR
        jmp  loop_
  @@read:
        call MotorOn                ; make motor on
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
  LocalLabel1:
  @@loop:
        mov  NormalKeyboard,FALSE
        mov  Error,er1Line
        call ChangeErrorF           ; line for no error
        call ReadFile               ; read a file
        cmp  StopRead,TRUE          ; if interrupt by ESC key
        je   error_ilmStop          ; go error message

        mov  Status,st3Line
        call ChangeStatus           ; line of one file read (not saved)
        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  NormalKeyboard,TRUE
        call WriteFileData          ; write info of file data
        SET_ERROR F                 ; set the lines if there's errors
        call ChangeErrorF
        cmp  Error,st1Line          ; is there an error ?
        jbe  loop_
  AnError:
        mov  bl,ilmChk
        call WriteInfoLine          ; line for checksum error
        READ_CHAR
        jmp  loop_

  output:
        mov  bl,ilmInput
        call WriteInfoLine            ; line for input name file
        call ShowCursor               ; show cursor for input
        call InputName                ; enter name file
        call HideCursor               ; hide cursor
        call SplitName                ; estract component of file name
        cmp  byte ptr [FName],0       ; there's not name ?
        jz   Error_ilmFile            ; then error
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        cmp  byte ptr [FExtension],0  ; there's not extension ?
        jnz  there_is_ext
        mov  byte ptr [FExtension],4
        mov  byte ptr [Fextension+1],'.'
        mov  byte ptr [FExtension+2],'T'
        mov  byte ptr [FExtension+3],'@'
        mov  byte ptr [FExtension+4],'0'
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],'.'
        mov  byte ptr [bx+InputBuffer+3],'T'
        mov  byte ptr [bx+InputBuffer+4],'@'
        mov  byte ptr [bx+InputBuffer+5],'0'
        mov  byte ptr [bx+InputBuffer+6],0   ; asciiz string
        jmp  update_video_name
  there_is_ext:
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],0   ; asciiz string
  update_video_name:
        call UpdateFileName              ; write actul file name into his line
        mov  OutFileSet,TRUE             ; the file name is set
        jmp  loop_

  Error_ilmFile:
        mov  bl,ilmFile
        call WriteInfoLine               ; line for error in file name
        mov  byte ptr [FName],4
        mov  byte ptr [FName+1],'n'
        mov  byte ptr [FName+2],'o'
        mov  byte ptr [FName+3],'n'
        mov  byte ptr [FName+4],'e'
        mov  byte ptr [FExtension],1
        mov  byte ptr [FExtension+1],' '
        call UpdateFileName             ; write actul file name into his line
        mov  OutFileSet,FALSE           ; the file name is non set
        READ_CHAR
        jmp  loop_

  write:
        cmp  Status,st3Line         ; there's a file read ?
        jz   @@cont
        mov  bl,ilmNoSave
        call WriteInfoLine          ; line for no save error
  @@wait:
        READ_CHAR
        jmp  loop_
  @@cont:
        cmp  OutFileSet,TRUE        ; there's a good name set ?
        je   @@cont2
        mov  bl,ilmNoName
        call WriteInfoLine
        jmp  @@wait
  @@cont2:
        call OpenFile               ; create a new file
        jc   loop_                  ; jump if error opening file
        mov  dx,offset(FHeader1)
        call SaveHeader             ; save the header
        jc   @@close                ; jump if error writing file
        mov  ax,SegBuffer1
        mov  cx,FileLength1
        inc  cx                     ; there's a checksum too
        call SaveFile               ; save the file
        jc   @@close                ; jump if error writing file
        mov  Status,stNormal
        call WriteSpace             ; erase video file information
        call ChangeStatus           ; line for normal status
        mov  Error,erNormal
        call ChangeError            ; line for normal error
  @@close:
        call CloseFile              ; close a file
        call SaveCopy2
        jmp  loop_

  exit: cmp  Status,st3LIne         ; is a file read but not saved
        jne  goexit
        mov  bl,ilmExit             ; line for exit but not saved
        call WriteInfoLine
        READ_CHAR
        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   goexit
        jmp  loop_

  goexit:
        call ShowCursor
        SET_INT_VECT 09h, Int09Save, []   ; insert int 09 Bios
        xor  al,al
        call ExitProc          ; terminate with return code
end Main

PROC:

CloseFile            close a file
ExitProc             write exit message and exit from program
InitScreen           inizialize standard screen
ReadBit              read one bit (carry/zero=bit read)
ReadChar             read one character
ReadFile             read the file block
ReadHeader           read header of a file
SaveFile             save the file data (AX=segment)
SaveHeader           save the header of the file (CX=segment)

File Format:
   output file .T@0:
 00       02         : Commodore 64
 01       0A         : Kernal
 02       13         : Tape
 03       05         : File
                     : versione 1.00
 04       Type       : Type of the Header
 05       shi        : Start address low
 06       slo        : Start address hi
 07       ehi        : End address low
 08       elo        : End address hi
 09       name
 ::        ::        : File name
 09+0F    name
 18       head_body
 ::        ::        : Header Body (normaly= 20h)
 C0+04-1  head_body
 C0+04    chkH       : Checksum of header
 C5       data
 ::        ::        : File data
 eof-1    data
 eof      chkF       : Checksum of file

29/11/97  1:05       : routine per leggere bit/char
30/11/97    30       : routine per leggere header
01/12/97    30   30  : routine per leggere file
03/12/97    55       : routine per save del file
08/12/97     5       : sistemazione errori per salti
22/01/98    30       : inserimento routine ver 1.00 e modifica per due copie
05/02/98  1:00       : sistemazione menu da routine ver 1.00 e changeerror
06/02/98  1:15    10 : aggiunte generali per leggere l'header
07/02/98  1:20    20 : aggiunte generali per leggere il file
08/02/98     5       : correzione per checksum del file
09/02/98    55       : aggiunte per length error
         ------
          8:10  1:00
