DOSSEG
LOCALS
JUMPS
.286
.MODEL small

_STACK segment para stack 'stack'
  dw 200h dup(?)
  EndStack LABEL BYTE
_STACK ends
assume ss:_stack

.DATA

TRUE    equ 1
FALSE   equ 0
IPORT   equ 3bdh     ; parallel control port register
BITMASK equ 80h
RATE_A  equ 1150     ; sperimentally value for type A
RATE_B  equ 650      ; sperimentally value for type B ??
RATE_C  equ 1350     ; sperimentally value for type C ??
RATE_D  equ 650      ; sperimentally value for type D ??
RATE_E  equ 1000     ; sperimentally value for type E ??
VIDEO_SEG equ 0B800h ; color video segment
RotDX  equ 1         ; dx rotation
RotSX  equ 2         ; sx rotation

StopRead    db FALSE    ; TRUE if we must not continue to read
Key         db ?        ; key press used by int 09 handler
NBit        db 0        ; number of bit to read
Counter     dw 1        ; counter for attribute memory pointer
OldValue    dw 0        ; store the value of counter
CharRead    db 0        ; the reading char
Temp        db ?        ; a temp. location
TypeF       db tyA      ; type of file to read
BlockType   db 03       ; type of block for type E of file
BlockNumber db ?        ; number of block
Rotation    db RotSX    ; type of rotation of byte
Position    dw ?        ; memorize actual position
CharLength  db 09       ; length of char
Chk         db ?        ; contain progressive checksum
Checksum    db ?        ; contain checksum read in file
CursorForm  dw ?        ; hold the actual form of the cursor
SegBuffer   dw ?        ; segment of memory buffer
FHandle     dw ?        ; file handle
FileLength  dw ?        ; length of input file
StartAddr   dw ?        ; start of program in C64 memory
StopAddr    dw ?        ; stop of program in C64 memory
RTIAddr     dw ?        ; address of RTI instruction (used by type C)
Status      db stNormal ; status of read process
Error       db erNormal ; error of read process
NormalKeyboard db TRUE  ; choose the type of keyboard (TRUE=bios)
MotorFlag   db FALSE    ; the state of motor
OutFileSet  db FALSE    ; if the name of output file is set

HexDigit db '0123456789ABCDEF'

TempBuffer db ?        ; temporally buffer for hex to string conversion
           db ?,?,?,?

InputBuffer db 40   ; max length
            db ?    ; effective length
            rept 43
              db ?
            endm
FPath db ?          ; file path (first is length)
      rept 28
        db ?
      endm
FName db ?          ; file name (first is length)
      rept 8
        db ?
      endm
FExtension db ?     ; file extension (first is length)
           rept 4
             db ?
           endm

Int09Save dd ?       ; contain Bios Int 09 address

stNormal equ 0  ; line of normal
st1line  equ 1  ; line of no file found
st2line  equ 2  ; line of one file found (not read)
st3line  equ 3  ; line of one file read (not save)

erNormal equ 0  ; line of normal
er1line  equ 1  ; line of no error
er2line  equ 2  ; line of checksum error
er3line  equ 3  ; line of wrong type
er4line  equ 4  ; line of stop by esc

tyA      equ 0  ; type A
tyB      equ 1  ; type B
tyC      equ 2  ; type C
tyD      equ 3  ; type D
tyE      equ 4  ; type E
maxType  equ 4  ; max type number

ilmChoose   equ  0; line for standard info
ilmInput    equ  1; line for input name file
ilmFile     equ  2; line for error in file name
ilmPLoad    equ  3; line for press tape (loading)
ilmStop     equ  4; line for interrupt by ESC key
ilmPath     equ  5; line for path not found
ilmAlready  equ  6; line for file already exists
ilmGeneric  equ  7; line for generic file error
ilmWrong    equ  8; line for wrong type found
ilmNoFile   equ  9; line for no file yet found
ilmChk      equ 10; line for checksum error
ilmNoSave   equ 11; line for no save error
ilmErSave   equ 12; line for save error
ilmExit     equ 13; line for exit but not saved
ilmNotSaved equ 14; line for not saved
ilmNoName   equ 15; line for no name set
ilmAddrEnd  equ 16; line for insert end address

ilm0  db 0Fh,'Select highlighted options desired                                  '
ilm1  db 0Fh,'Insert output filename:                                             '
ilm2  db 04h,'ERROR: No name of file is specified (press any key to continue)     '
ilm3  db 0Fh,'Press PLAY on tape (Use ESC key to abort operation)                 '
ilm4  db 04h,'WARNING: Operation interrupt by user (press any key to continue)    '
ilm5  db 04h,'ERROR: Path not found (press any key to continue)                   '
ilm6  db 04h,'WARNING: Output file already exists. Overwrite (Yes/No) ?           '
ilm7  db 04h,'ERROR: Internal DOS error in file creating routine (press any key)  '
ilm8  db 04h,'WARNING: Found an wrong header file. Press Y to continue anyway     '
ilm9  db 04h,'ERROR: Can''t read a file before found it with S option (press a key)'
ilm10 db 04h,'WARNING: Probably read error, save with W option is not raccomanded '
ilm11 db 04h,'ERROR: There''s nothing file to save (press any key to continue)     '
ilm12 db 04h,'ERROR: There''s a problem saving output file (press any key)         '
ilm13 db 04h,'WARNING: File not saved, are you sure to exit (Yes/No) ?            '
ilm14 db 04h,'WARNING: File not saved, continue anyway (Yes/No) ?                 '
ilm15 db 04h,'ERROR: No file name are selected with O option (press any key)      '
ilm16 db 0Fh,'Insert ending address of program:                                   '
InfoLineTable dw offset ilm0
              dw offset ilm1
              dw offset ilm2
              dw offset ilm3
              dw offset ilm4
              dw offset ilm5
              dw offset ilm6
              dw offset ilm7
              dw offset ilm8
              dw offset ilm9
              dw offset ilm10
              dw offset ilm11
              dw offset ilm12
              dw offset ilm13
              dw offset ilm14
              dw offset ilm15
              dw offset ilm16

StringTyA db 'GOLDEN SOFTWARE$'
StringTyB db 'GALADRIEL SW.  $'
StringTyC db 'SYSTEM 3       $'
StringTyD db 'GOLDEN SOFTWARE$'
StringTyE db 'MASTERTRONIC   $'

VideoMask label byte
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0
db ' ', 0, '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0
db '', 4, '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4
db '', 4, '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4
db '', 4, '', 4, '', 4, ' ', 0, ' ', 0, '', 4, '', 4, '', 4
db '', 4, '', 4, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'b',15, 'y',15, ' ', 0, 'I',15, 'C',15, 'E',15
db ' ', 0, 'T',15, 'E',15, 'A',15, 'M',15, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '', 5, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0
db '', 5, '', 5, '', 5, '', 5, '', 5, ' ', 0, ' ', 0, '', 5
db ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0, '', 5, '', 5
db '', 5, '', 5, ' ', 0, ' ', 0, ' ', 0, '', 5, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '6', 2, '4', 2,  16, 2
db  17, 2, 'P', 2, 'C', 2, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 'v', 9, 'e', 9, 'r', 9, ' ', 0, '3', 9, '.', 9
db '0', 9, '0', 9, '-', 9, '1', 9, '9', 9, '9', 9, '7', 9, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, '',13, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '',13, '',13, '',13, '',13, '',13, ' ', 0, ' ', 0
db '',13, ' ', 0, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, ' ', 0, '',13, '',13
db '',13, '',13, '',13, ' ', 0, ' ', 0, '',13, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, 's', 9, 'h', 9, 'a', 9, 'r', 9, 'e', 9, 'w', 9
db 'a', 9, 'r', 9, 'e', 9, ' ', 9, 's', 9, 'o', 9, 'f', 9, 't', 9
db '.', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'M',15, 'o', 7, 't', 7, 'o', 7, 'r', 7
db ' ', 7, 'O', 7, 'n', 7, '/', 7, 'O', 7, 'f', 7, 'f', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'O',15, 'u', 7
db 't', 7, 'p', 7, 'u', 7, 't', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, 'n', 7, 'a', 7, 'm', 7, 'e', 7
db ':', 7, ' ', 7, 'n', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'S',15, 'e', 7, 'a', 7, 'r', 7, 'c', 7
db 'h', 7, '/', 7, 'R',15, 'e', 7, 'a', 7, 'd', 7, ' ', 7, 'f', 7
db 'o', 7, 'r', 7, ' ', 0, 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'W',15, 'r', 7
db 'i', 7, 't', 7, 'e', 7, ' ', 7, 'P', 7, 'C', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, 'T',15, 'y', 7, 'p', 7, 'e', 7, ':', 7
db ' ', 0, 'A',15, ' ', 0, 'B', 7, ' ', 0, 'C', 7, ' ', 0, 'D', 7
db ' ', 0, 'E', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'e', 7, 'X',15
db 'i', 7, 't', 7, ' ', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, ' ', 0, ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, '^', 7, ' ', 0, '^', 7, ' ', 0, '^', 7, ' ', 0, '^', 7
db ' ', 0, '^', 7, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '^', 7
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ', 0, 'T', 7, 'y', 7, 'p', 7, 'e', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'S', 7, 't', 7, 'a', 7, 't', 7
db 'u', 7, 's', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'f', 7
db 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7, 'n', 7
db 'd', 7, '/', 7, 'r', 7, 'e', 7, 'a', 7, 'd', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'F', 7, 'i', 7, 'r', 7, 's', 7, 't', 7, ' ', 7
db 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'f', 7, 'o', 7, 'u', 7
db 'n', 7, 'd', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 'r', 7, 'e', 7, 'a', 7, 'd', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'S', 7, 'e', 7, 'c', 7, 'o', 7, 'n', 7, 'd', 7
db ' ', 7, 'a', 7, 'd', 7, 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, 'o', 7, 'n', 7, 'e', 7, ' ', 7
db 'f', 7, 'i', 7, 'l', 7, 'e', 7, ' ', 7, 'r', 7, 'e', 7, 'a', 7
db 'd', 7, ' ', 7, ' ', 7, '(', 7, 'n', 7, 'o', 7, 't', 7, ' ', 7
db 's', 7, 'a', 7, 'v', 7, 'e', 7, ')', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'R', 7, 'u', 7, 'n', 7, ' ', 7, 'a', 7, 'd', 7
db 'd', 7, 'r', 7, '.', 7, ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'B', 7, 'l', 7, 'o', 7, 'c', 7, 'k', 7, ' ', 7
db 'n', 7, 'u', 7, 'm', 7, 'b', 7, 'e', 7, 'r', 7, ':', 7, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, 'E', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ':', 7, ' ', 7, 'n', 7, 'o', 7, ' ', 7, 'e', 7, 'r', 7
db 'r', 7, 'o', 7, 'r', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'c', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7
db 's', 7, 'u', 7, 'm', 7, ' ', 7, 'e', 7, 'r', 7, 'r', 7, 'o', 7
db 'r', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'N', 7, 'u', 7, 'm', 7, 'b', 7, 'e', 7, 'r', 7
db ' ', 7, 'o', 7, 'f', 7, ' ', 7, 'b', 7, 'y', 7, 't', 7, 'e', 7
db ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 'w', 7, 'r', 7, 'o', 7, 'n', 7, 'g', 7
db ' ', 7, 't', 7, 'y', 7, 'p', 7, 'e', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, 'C', 7, 'h', 7, 'e', 7, 'c', 7, 'k', 7, 's', 7
db 'u', 7, 'm', 7, ':', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, 's', 7, 't', 7, 'o', 7, 'p', 7, ' ', 7
db 'f', 7, 'o', 7, 'r', 7, 'c', 7, 'e', 7, 'd', 7, ' ', 7, 'b', 7
db 'y', 7, ' ', 7, 'E', 7, 'S', 7, 'C', 7, ' ', 7, ' ', 7, ' ', 7
db ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, ' ', 7, '', 9

db '', 9, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0
db ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, ' ', 0, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

db '', 9, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15
db ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, ' ',15, '', 9

db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9
db '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9, '', 9

ProgInfo db 'READER ver 3.00 (C) ICE TEAM inc. 1997-98', 0Dh, 0Ah, '$'
er0      db 'Thanks to have use this program.$'
er1	 db 'No eougth memory: program aborted.$'
erTable  dw offset er0
	 dw offset er1

.CODE

CHANGE_CURSOR_POSITION macro pos
        mov  ah,02h
        mov  bh,0         ; page=0
        mov  dx,pos       ; DH=row DL=col.
        int  10h          ; change cursor position
endm

WRITE_CHAR macro char, attr
        mov  ax,0900h+char
        mov  bx,0000h+attr ; page=0
        mov  cx,1          ; 1 char
        int  10h           ; write one caracter
endm

WRITE_NCHAR macro char, attr, num
        mov  ax,0900h+char
        mov  bx,00+attr   ; page 0 + attrib
        mov  cx,num
        int  10h          ; write cx char
endm

GET_INT_VECT macro num, vect
        mov  ax,35h*256+num   ; DOS: get int vect
        int  21h
        mov  word ptr[vect],bx
        mov  word ptr[vect+2],es
endm

SET_INT_VECT macro num, vect, par
        push ds
        ifidn <par>,<[]>
             mov  dx,word ptr [vect]
             mov  ax,word ptr [vect+2]
             mov  ds,ax
        else
             mov  dx,offset(vect)
             mov  ax,seg(vect)
             mov  ds,ax
        endif
        mov  ax,25h*256+num   ; DOS: set int vect
        int  21h
        pop  ds
endm

READ_CHAR macro
 @@loop_:
        mov  ah,01
        int  16h
        jz   @@loop_       ; AL=char read if ZF=0

        mov  ah,00
        int  16h           ; AL=char read
endm

; interrupt routine for the 09h keyboard service
Int09 proc far
        push ds
        push ax
        pushf
        mov  ax,@data
        mov  ds,ax
        cmp  NormalKeyboard,TRUE
        jne  NotNormal
        call Int09Save
        pop  ax
        pop  ds
        iret

  NotNormal:
        in   al,60h             ; read key scan code
        mov  Key,al
        in   al,61h             ; read status
        mov  ah,al
        or   al,80h             ; set reset bit
        out  61h,al             ; out reset bit
        xchg ah,al
        out  61h,al             ; out previous status

        cmp  Key,01h            ; ESC key
        jne  cont

  SetExit:
        mov  StopRead,TRUE

  cont:
        cli
        mov  al,20h
        out  20h,al            ; end of interrupt
        popf
        pop  ax
        pop  ds
        iret
Int09 endp

LOADING_EFFECT macro                  ; create loading effect
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,Counter               ; get actually video color char position
        mov  al,byte ptr es:[bx]      ; get actually video color
        add  al,16                    ; set to next background color
        and  al,01111111b             ; no intermittence
        mov  byte ptr es:[bx],al
        add  Counter,2                ; set to next position
        cmp  Counter,4001             ; is is over then visible region ?
        jne  @@cont
        mov  Counter,1                ; yes, set to first position
    @@cont:
        pop  es
endm

ReadBitA proc                ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE_A     ; if cx<RATE_A bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBitA endp

ReadCharA label near
        mov  al,08h
ReadCharA_ proc              ; read a char
        mov  NBit,al
  @@loop:
        call ReadBitA
        rcr  CharRead,1
         cmp  StopRead,TRUE
         je   @@exit

        LOADING_EFFECT

        dec  NBit
        jne  @@loop
        mov  al,CharRead  ; return AL=char read
  @@exit:
        ret
ReadCharA_ endp

ReadFileA proc              ; try to find and read a file
  @@SearchSync:
        mov  al,09h           ; read 9 bit to find sync.
        call ReadCharA_
         cmp  StopRead,TRUE
         je   @@exit
        cmp  al,02h
        jne  @@SearchSync
  @@SyncOk:
        call ReadCharA         ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        cmp  al,02h           ; are we sinc.
        je   @@SyncOk
        cmp  al,52h           ; is a correct file ?
        jne  @@SearchSync
        call ReadCharA
        cmp  al,42h           ; is a correct file ?
        jne  @@SearchSync
        call ReadCharA                   ; al=char read
        mov  byte ptr [StartAddr],al
        call ReadCharA                   ; al=char read
        mov  byte ptr [StartAddr+1],al
        call ReadCharA                   ; al=char read
        mov  byte ptr [StopAddr],al
        call ReadCharA                   ; al=char read
        mov  byte ptr [StopAddr+1],al
        mov  ax,StopAddr               ; calculate length of file
        sub  ax,StartAddr
        mov  FileLength,ax
        mov  Chk,0
        mov  di,9                  ; first 9 bytes are for header
        xor  si,si
        mov  ax,SegBuffer
        mov  es,ax
  @@loop:
        call ReadCharA              ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        stosb
        xor  Chk,al
        inc  si                    ; another byte reads
        cmp  si,FileLength
        jne  @@loop
  @@exit:
         call ReadCharA            ; al=checksum
         mov  CheckSum,al          ; save checksum read
         ret
ReadFileA endp

ReadBitB proc                ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE_B     ; if cx<RATE_B bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBitB endp

ReadCharB proc              ; read a char of type B
        mov  al,08h
        mov  NBit,al
  @@loop:
        call ReadBitB
        rcl  CharRead,1
         cmp  StopRead,TRUE
         je   @@exit

        LOADING_EFFECT

        dec  NBit
        jne  @@loop
        mov  al,CharRead  ; return AL=char read
  @@exit:
        ret
ReadCharB endp

ReadFileB proc           ; try to find and read a file
  @@SearchSync:
        call ReadBitB           ; read one bit
        rcl  CharRead,1         ; insert it in a byte
         cmp  StopRead,TRUE
         je   @@exit
        mov  al,CharRead
        cmp  al,02h             ; if it's 02 ok
        jne  @@SearchSync
        mov  Temp,10h           ; try to find 10h, .. 09, 08.. 01 sequence
  @@SyncOk:
        call ReadCharB          ; read a char in al
        cmp  al,02h             ; if it's 02, we are in syncronization region
        je   @@SyncOk
  @@Seq:
        cmp  al,Temp            ; is it in 10h..01 sequence ?
        jne  @@SearchSync
        call ReadCharB
        dec  Temp
        jne  @@Seq
                                ; now there's a file data
        mov  ax,0801h              ; set sefault value
        mov  StartAddr,ax
        mov  ax,StopAddr           ; calculate length of file
        sub  ax,StartAddr
        mov  FileLength,ax
        mov  Chk,0
        mov  di,9                  ; first 9 bytes are for header
        xor  si,si
        mov  ax,SegBuffer
        mov  es,ax
  @@loop:
        call ReadCharB              ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        stosb
        xor  Chk,al
        inc  si                    ; another byte reads
        cmp  si,FileLength
        jne  @@loop
        call ReadCharB             ; al=char read
        mov  Checksum,al           ; save checksum
  @@exit:
        ret
ReadFileB endp

ReadBitC proc                ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE_C     ; if cx<RATE_C bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBitC endp

ReadCharC proc              ; read a char of type C
        mov  CharRead,01h   ; a bit 0='1' => we have read 8 bit
  @@loop:
         cmp  StopRead,TRUE
         je   @@exit

        LOADING_EFFECT
        call ReadBitC
        rcl  CharRead,1

        jnc  @@loop         ; if carry=0 we read again
        mov  al,CharRead    ; return AL=char read
        add  Chk,al         ; calculate ckecksum
        inc  Chk
  @@exit:
        ret
ReadCharC endp

ReadFileC proc              ; try to find and read a file of type C
        mov  ax,SegBuffer
        mov  es,ax
        mov  di,5           ; debug
        xor  si,si
        mov  Chk,0; 16h
  @@SearchSync:
        call ReadBitC           ; read one bit
        rcl  CharRead,1         ; insert it in a byte
         cmp  StopRead,TRUE
         je   @@exit
        mov  al,CharRead
        cmp  al,0Fh             ; if it's 0F we are in syncronization step
        jne  @@SearchSync
  @@Sync:
        call ReadCharC          ; read one char
         cmp  StopRead,TRUE
         je   @@exit
        cmp  al,0Fh
        je   @@Sync
        cmp  al,0F0h            ; if it's F0 ok
        jne  @@SearchSync
  @@SyncOk:

        call ReadCharC          ; read one char
        stosb                   ; store the step byte
        mov  Position,di        ; store the actual position
        add  di,2               ; there will be the length of block

         cmp  StopRead,TRUE
         je   @@exit

  @@Another:
        call ReadCharC          ; read one char
        stosb
        inc  si
        call ReadBitC           ; read one bit
        jnc  @@EndBlock         ; carry=0 => end of data in a block

        jmp  @@Another

  @@EndBlock:
        call ReadBitC           ; read one bit
        jnc  @@EndFile          ; carry=1 => there's another block

        mov  bx,Position
        mov  es:[bx],si   ; store the length
        xor  si,si
        jmp  @@SyncOk

  @@EndFile:
        mov  bx,Position
        mov  es:[bx],si   ; store the length
        xor  si,si
        call ReadCharC          ; read one char
        mov  CheckSum,al        ; save readed checksum
  @@exit:
        mov  FileLength,di  ; debug
        mov  Status,st3line ; debug
        mov  StopRead,FALSE
        ret
ReadFileC endp

ReadBitD proc                ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE_D     ; if cx<RATE_D bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        rcr  ah,1          ; return Carry=bit readed
  @@exit:
        ret
ReadBitD endp

ReadCharD proc            ; read one char of type D
        mov  al,08h
        mov  NBit,al          ; read 8 bits
  @@loop:
        call ReadBitD         ; read one bit
        rcl  CharRead,1       ; insert the bit in the char that we are reading
         cmp  StopRead,TRUE
         je   @@exit

        LOADING_EFFECT

        dec  NBit
        jne  @@loop
        mov  al,CharRead      ; return AL=char read
  @@exit:
        ret
ReadCharD endp

ReadFileD proc            ; try to find and read a file of type D
  @@SearchSync:
        call ReadBitD           ; read one bit
        rcl  CharRead,1         ; insert it in a byte
         cmp  StopRead,TRUE
         je   @@exit
        mov  al,CharRead
        cmp  al,02h             ; if it's 02 we are in syncronization step
        jne  @@SearchSync

        mov  Temp,09h           ; try to find 09h, 08.. 01 sequence
  @@SyncOk:
         cmp  StopRead,TRUE
         je   @@exit
        call ReadCharD          ; read a char in al
        cmp  al,02h             ; if it's 02, we are in syncronization region
        je   @@SyncOk
  @@Seq:
        cmp  al,Temp            ; is it in 09h..01 sequence ?
        jne  @@SearchSync
        call ReadCharD
        dec  Temp
        jne  @@Seq
                                ; now there's a file data
        mov  byte ptr [StartAddr],al
        call ReadCharD                   ; al=char read
        mov  byte ptr [StartAddr+1],al
        call ReadCharD                   ; al=char read
        mov  byte ptr [StopAddr],al
        call ReadCharD                   ; al=char read
        mov  byte ptr [StopAddr+1],al

        mov  ax,StopAddr                 ; calculate length of file
        sub  ax,StartAddr
        mov  FileLength,ax
        call ReadCharD                   ; al=char read
        mov  byte ptr [RTIAddr+1],al
        call ReadCharD                   ; al=char read
        mov  byte ptr [RTIAddr],al
        mov  di,0Ah                      ; first 0Ah bytes are for header
        xor  si,si
        mov  ax,SegBuffer
        mov  es,ax
  @@loop:
        call ReadCharD                   ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        stosb
        inc  si                          ; another byte reads
        cmp  si,FileLength
        jne  @@loop
  @@exit:
        ret
ReadFileD endp

ReadBitE proc                ; read one bit (carry=bit read)
        mov  dx,IPORT
  @@loop1:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jnz   @@loop1
  @@loop0:
         cmp  StopRead,TRUE
         je   @@exit
        in   al,dx
        test  al,BITMASK
        jz   @@loop0

  @@readvalue:
        mov  al,6           ;write actual value into buffer
        out  43h,al
        jmp  @@delay
  @@delay:
        in   al,40h
        mov  bl,al
        in   al,40h
        mov  bh,al          ; bx=actual value of counter

        mov  cx,OldValue
        sub  cx,bx
        mov  OldValue,bx
 @@setbit:
        xor  ah,ah
        cmp  cx,RATE_E     ; if cx<RATE_E bit=0 else bit=1
        jbe  @@nothing
        inc  ah
 @@nothing:
        cmp  Rotation,RotDX
        je   @@dx
        rcr  ah,1          ; return Carry=bit readed
        rcl  CharRead,1
        cmp  CharRead,0
        jmp  @@exit
  @@dx:
        rcr  ah,1          ; return Carry=bit readed
        rcr  CharRead,1
        cmp  CharRead,0
  @@exit:
        ret
ReadBitE endp

ReadCharE proc            ; read one char of type E
        mov  al,CharLength
        mov  NBit,al          ; read 8 bits
  @@loop:
        call ReadBitE         ; read one bit
         cmp  StopRead,TRUE
         je   @@exit

        LOADING_EFFECT

        dec  NBit
        jne  @@loop
        mov  al,CharRead      ; return AL=char read
        test al,al
  @@exit:
        ret
ReadCharE endp

ReadFileE proc            ; try to find and read a file of type E
        mov  BlockNumber,0
  @@InitSync:
        mov  CharRead,7Fh
  @@SearchSync:
         cmp  StopRead,TRUE
         je   @@exit
        call ReadBitE           ; read one bit
        jne  @@SearchSync
        call ReadCharE          ; read one char
        jne  @@InitSync
  @@loop:
         cmp  StopRead,TRUE
         je   @@exit
        call ReadCharE          ; read one char
        je   @@loop
        cmp  CharRead,16h       ; if 16h we are syncronization
        jne  @@InitSync
                        ; now there's a file data
        mov  ax,SegBuffer
        mov  es,ax
        mov  di,04                       ; first 04h bytes are for header
 @@Another:
        mov  al,BlockType
        stosb
        cmp  al,03
        jbe  @@ReadAddr
        mov  ax,di               ; preparate new pointer
        add  al,BlockType        ; add the bytes of block
        adc  ah,0
        sub  al,03               ; sub first 4 bytes of header
        sbb  ah,0
        mov  si,ax
 @@loop2:
        call ReadCharE                   ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        stosb
        cmp  si,di
        jne  @@loop2

 @@ReadAddr:
        call ReadCharE                   ; al=char read
        mov  byte ptr [StopAddr+1],al
        stosb
        call ReadCharE                   ; al=char read
        mov  byte ptr [StopAddr],al
        stosb
        call ReadCharE                   ; al=char read
        mov  byte ptr [StartAddr+1],al
        stosb
        call ReadCharE                   ; al=char read
        mov  byte ptr [StartAddr],al
        stosb
        mov  ax,StopAddr                 ; calculate length of file
        sub  ax,StartAddr
        mov  FileLength,ax
        cmp  FileLength,0
        jne  @@jump
        inc  FileLength
  @@jump:
                                         ; save address
      ;  mov  al,byte ptr [StartAddr]
      ;  stosb
      ;  mov  al,byte ptr [StartAddr+1]
      ;  stosb
      ;  mov  al,byte ptr [StopAddr]
      ;  stosb
      ;  mov  al,byte ptr [StopAddr+1]
      ;  stosb
        xor  si,si
  @@loop1:
        call ReadCharE                   ; al=char read
         cmp  StopRead,TRUE
         je   @@exit
        stosb
        inc  si                          ; another byte reads
        cmp  si,FileLength
        jne  @@loop1

        inc  BlockNumber
        cmp  StartAddr,03A4h      ; are we change number of header to read ?
        je   @@ChangeHeader
        cmp  StartAddr,0347h      ; are we change the rotation of byte ?
        je   @@ChangeRot
        cmp  startAddr,034Bh      ; are we change byte length ?
        je   @@ChangeLength
        cmp  StartAddr,03BBh      ; are we at the end of file ?
        jne  @@Another
        jmp  @@exit
  @@ChangeHeader:
        mov  bx,di
        sub  bx,si
        mov  al,es:[bx]
        mov  BlockType,al
        jmp  @@Another

  @@ChangeRot:
        cmp  CharRead,66h
        je   @@dx
        mov  Rotation,RotSX
        jmp  @@Another
  @@dx:
        mov  Rotation,RotDX
        jmp  @@Another

  @@ChangeLength:
        mov  al,CharRead
        mov  CharLength,al
        jmp  @@Another

  @@exit:
        mov  StartAddr,0
        mov  StopAddr,di
        mov  FileLength,di
        mov  StopRead,False
        mov  Status,st2line
        ret
ReadFileE endp

MotorOn proc              ; on the cassette motor

        mov  MotorFlag,TRUE

        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 0Fh          ; 'O', attrib.=15
        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=14
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOn endp

MotorOff proc             ; off the cassette motor

        mov  MotorFlag,FALSE

        CHANGE_CURSOR_POSITION 060Ch ; row=7 col.=13
        WRITE_CHAR 4Fh 0Fh           ; 'O', attrib=15
        CHANGE_CURSOR_POSITION 0609h ; row=7 col.=10
        WRITE_CHAR 4Fh, 07h          ; 'O', attrib.=7
        ret
MotorOff endp

WriteVideoMask proc        ; write the video mask
       mov  ax,VIDEO_SEG
       mov  es,ax
       xor  di,di
       mov  si,offset(VideoMask)
       mov  cx,25*80
       rep  movsw
       ret
WriteVideoMask endp

WriteInfoLine proc        ; write message into info line (BL set message)
        mov  dx,1702h     ; row=24 col.=3
        xor  bh,bh        ; page =0
        add  bl,bl        ; bl=number of infomessage
        mov  bp,[bx+offset InfoLineTable]
        mov  bl,ds:[bp]   ; attrib.
        inc  bp
        mov  ax,@data
        mov  es,ax        ; ES:BP=string
        mov  ax,1300h
        mov  cx,68        ; string length
        int  10h          ; write infoline message
        ret
WriteInfoLine endp

WriteType proc            ; write type on screen
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  al,07h
        mov  es:[10*160+19],al ; attrib for type A
        mov  es:[10*160+23],al ; attrib for type B
        mov  es:[10*160+27],al ; attrib for type C
        mov  es:[10*160+31],al ; attrib for type D
        mov  es:[10*160+35],al ; attrib for type E
        mov  bx,10*160+19
        mov  al,TypeF
        shl  al,2
        add  bl,al
        mov  al,15
        mov  es:[bx],al
        CHANGE_CURSOR_POSITION 0D0Ch ; row=14 col.=13
        cmp  TypeF,tyA
        jne  @@tyB
        mov  dx,offset(StringTyA)
        jmp  @@write
  @@tyB:
        cmp  TypeF,tyB
        jne  @@tyC
        mov  dx,offset(StringTyB)
        jmp  @@write
  @@tyC:
        cmp  TypeF,tyC
        jne  @@tyD
        mov  dx,offset(StringTyC)
        jmp  @@write
  @@tyD:
        cmp  TypeF,tyD
        jne  @@tyE
        mov  dx,offset(StringTyD)
        jmp  @@write
  @@tyE:
        mov  dx,offset(StringTyE)
  @@write:
        mov  ah,09h          ; write string ds:dx
        int  21h
        ret
WriteType endp

InputName proc            ; read input file name by keyboard

        CHANGE_CURSOR_POSITION 171Ah  ; row=24 col.=27
        mov  ah,0Ah
        mov  dx,offset(InputBuffer)
        int  21h          ; input a string
        ret
InputName endp

StringCopy proc           ; copy one string (ds:si) in another (es:di)
        sub  dx,bx
        cmp  ax,bx
        jb   lower
        mov  ax,bx
  lower:
        stosb             ; save length
        mov  cx,ax
        add  bx,si
        rep  movsb        ; copy string
        mov  si,bx
        ret
StringCopy endp

SplitName proc            ; split file name component
        mov  ax,@data
        mov  es,ax
        cld
        mov  si,offset(InputBuffer+1)
        lodsb             ; al=length of input name string
        mov  dl,al
        xor  dh,dh        ; dx=length
        mov  bx,dx
        or   bx,bx        ; ?=0
        je   zero
  @@loop:
        cmp  byte ptr [bx+si-1],'\'
        je   zero
        cmp  byte ptr [bx+si-1],':'
        je   zero
        dec  bx
        jne  @@loop
  zero:
        mov  ax,28        ; max path length
        mov  di,offset(FPath)
        call StringCopy
        xor  bx,bx
        jmp  for_name
  continue:
        cmp  byte ptr [bx+si],'.'
        je   name_found
        inc  bx
  for_name:
        cmp  bx,dx
        jne  continue
  name_found:
        mov  ax,08
        mov  di,offset(FName)
        call StringCopy
        mov  bx,dx
        mov  ax,0004
        mov  di,offset(FExtension)
        call StringCopy
        ret
SplitName endp

UpdateFileName proc       ; write actul file name into his line
        CHANGE_CURSOR_POSITION 0642h ; row=7 col.=67
        mov  si,offset(FName+1)
        mov  cl,byte ptr [FName] ; length of name
        xor  ch,ch
        cld
  @@loop:
        lodsb
        cmp  al,'a'
        jb   @@not
        cmp  al,'z'
        ja   @@not
        and  al,11011111b  ; make char upper
  @@not:
        mov  ah,0Eh
        xor  bh,bh        ; page=0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop

        mov  si,offset(FExtension+1)
        mov  cl,byte ptr [FExtension] ; length of extension
  @@loop1:
        lodsb
        cmp  al,'a'
        jb   @@not1
        cmp  al,'z'
        ja   @@not1
        and  al,11011111b  ; make char upper
  @@not1:
        mov  ah,0Eh
        mov  bh,00;07h    ; page=0 color=7
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop1
                          ; calculate if name<max name
        mov  cl,byte ptr [FName]
        add  cl,byte ptr [FExtension]
        mov  ch,12
        sub  ch,cl
        jz   @@exit      ; if not equal we must delete the extra
        mov  cl,ch
        xor  ch,ch
  @@loop2:
        mov  ax,0E20h
        mov  bh,00        ; page 0
        int  10h          ; write char in AL
        cmp  cx,01
        loopnz @@loop2
  @@exit:
        ret
UpdateFileName endp

ChangeStatus proc         ; change color of status line
        mov  dl,Status
        cmp  dl,stNormal  ; line of normal
        je   @@Normal
        cmp  dl,st1line   ; line of no file found
        je   stline1
        cmp  dl,st2line   ; line of one file found (not read)
        je   stline2
        mov  bx,0707h     ; 1=07, 2=07, 3=0F color
        mov  dh,0Fh
        jmp  modify
  @@Normal:
        mov  bx,0707h     ; 1=07, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline1:
        mov  bx,0F07h     ; 1=0F, 2=07, 3=07 color
        mov  dh,07h
        jmp  modify
  stline2:
        mov  bx,070Fh     ; 1=0F, 2=0F, 3=07 color
        mov  dh,07h
  modify:
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  di,13*80*2+51*2+1  ; line of no file found
        mov  cx,001Ah
  @@loop:
        mov  es:di,bh
        add  di,2
        loopne @@loop
        mov  di,14*80*2+51*2+1  ; line of one file found (not read)
        mov  cx,001Ah
  @@loop1:
        mov  es:di,bl
        add  di,2
        loopne @@loop1
        mov  di,15*80*2+51*2+1  ; line of one file read (not save)
        mov  cx,001Ah
  @@loop2:
        mov  es:di,dh
        add  di,2
        loopne @@loop2
        ret
ChangeStatus endp

ChangeError proc          ; change color of error line
        mov  dl,Error
        cmp  dl,erNormal  ; line of normal
        je   @@Normal
        cmp  dl,er1line   ; line of no error
        je   erLine1
        cmp  dl,er2line   ; line of checksum error
        je   erLine2
        cmp  dl,er3line   ; line of wrong type
        je   erLine3
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,070Fh     ; 3=07, 4=0F
        jmp  modify2
  @@Normal:
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine1:
        mov  bx,0F07h     ; 1=0F, 2=07
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine2:
        mov  bx,070Fh     ; 1=07, 2=0F
        mov  dx,0707h     ; 3=07, 4=07
        jmp  modify2
  erLine3:
        mov  bx,0707h     ; 1=07, 2=07
        mov  dx,0F07h     ; 3=0F, 4=07
  modify2:
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  di,17*80*2+51*2+1  ; line of no error
        mov  cx,001Ah
  @@loop:
        mov  es:di,bh
        add  di,2
        loopne @@loop
        mov  di,18*80*2+51*2+1  ; line of checksum error
        mov  cx,001Ah
  @@loop1:
        mov  es:di,bl
        add  di,2
        loopne @@loop1
        mov  di,19*80*2+51*2+1  ; line of wrong type error
        mov  cx,001Ah
  @@loop2:
        mov  es:di,dh
        add  di,2
        loopne @@loop2
        mov  di,20*80*2+51*2+1  ; line of stop by esc error
        mov  cx,001Ah
  @@loop3:
        mov  es:di,dl
        add  di,2
        loopne @@loop3
        ret
ChangeError endp

WriteSpace proc           ; erase video file information
        CHANGE_CURSOR_POSITION 0E11h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for start addrs
        CHANGE_CURSOR_POSITION 0F11h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for stop addrs
        CHANGE_CURSOR_POSITION 1011h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for run addrs
        CHANGE_CURSOR_POSITION 1111h
        WRITE_NCHAR ' ', 0Fh, 2         ; line for block numbers
        CHANGE_CURSOR_POSITION 1311h
        WRITE_NCHAR ' ', 0Fh, 4         ; line for number of byte
        CHANGE_CURSOR_POSITION 1411h
        WRITE_NCHAR ' ', 0Fh, 2         ; line for chksum
        ret
WriteSpace endp

RestoreAttribute proc          ; restore black attribute to video
        push es
        mov  ax,VIDEO_SEG
        mov  es,ax
        mov  bx,1
        mov  cx,2000           ; all video memory
  @@loop:
        mov  al,es:[bx]
        and  al,00001111b      ; set background=black
        mov  es:[bx],al
        add  bx,2
        loopnz @@loop
        pop  es
        mov  Counter,1         ; set to start of attributes
        ret
RestoreAttribute endp

WriteFileInfo proc        ; write info about header of tape file to video
        mov  ax,@data
        mov  es,ax        ; es used byte int 10h

        cmp  TypeF,tyA    ; is type A of file ?
        je   @@Standard
        cmp  TypeF,tyB
        je   @@Standard
        cmp  TypeF,tyC
        je   @@System3
        cmp  TypeF,tyD
        je   @@tyD

  @@tyE:
        mov  al,BlockNumber
        call HexByte         ; convert hex byte to string
        mov  dh,11h
        call WriteNumInfo    ; write numeric string info
        mov  ax,FileLength
        call HexWord         ; convert hex word to string
        mov  dh,13h
        call WriteNumInfo    ; write numeric string info
        jmp  @@exit

  @@Standard:
        mov  ax,StartAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Eh       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,StopAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Fh       ; row
        call WriteNumInfo ; write numeric string info

        mov  ax,StopAddr
        mov  bx,StartAddr
        sub  ax,bx
        mov  FileLength,ax
        call HexWord      ; convert hex word to string
        mov  dh,13h
        call WriteNumInfo ; write numeric string info
        mov  al,Checksum
        call HexByte      ; convert hex byte to string
        mov  dh,14h       ; row
        call WriteNumInfo ; write numeric string info
        jmp  @@exit

  @@System3:
        mov  al,Chk
        call HexByte      ; convert hex byte to string
        mov  dh,13h
        call WriteNumInfo ; write numeric string info
        mov  al,Checksum
        call HexByte      ; convert hex byte to string
        mov  dh,14h       ; row
        call WriteNumInfo ; write numeric string info
        jmp  @@exit

  @@tyD:
        mov  ax,StartAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Eh       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,StopAddr
        call HexWord      ; convert hex word to string
        mov  dh,0Fh       ; row
        call WriteNumInfo ; write numeric string info
        mov  ax,RTIAddr
        call HexWord      ; convert hex string to word
        mov  dh,10h       ; row
        call WriteNumInfo ; write numeric string info

        mov  ax,StopAddr
        mov  bx,StartAddr
        sub  ax,bx
        mov  FileLength,ax
        call HexWord      ; convert hex word to string
        mov  dh,13h
        call WriteNumInfo ; write numeric string info
        jmp  @@exit

  @@exit:
        ret
WriteFileInfo endp

WriteNumInfo proc         ; write numeric string info
        mov  dl,11h                   ; col=dl
        mov  ax,1300h
        mov  bx,000Fh                 ; page=0, attrib.=0F
        xor  ch,ch
        mov  cl,byte ptr [TempBuffer] ; string length
        mov  bp,offset(TempBuffer+1)
        int  10h                      ; write string es:bp
        ret
WriteNumInfo endp

HideCursor proc           ; make the cursor invisible
       mov  ah,03
       xor  bh,bh         ; page 0
       int  10h           ; info about corsor
       mov  CursorForm,cx ; form of the cursor

       mov  ah,01h
       mov  ch,20h        ; invisible cursor
       int  10h           ; set cursor form
       ret
HideCursor endp

ShowCursor proc           ; make the cursor visible
       mov  ah,01h
       mov  cx,CursorForm
       int  10h           ; set form of the cursor as normal
       ret
ShowCursor endp

HexByte proc              ; convert hex byte to string
        mov  byte ptr [TempBuffer],2
        xor  bh,bh
        mov  bl,al                      ; al=hex
        shr  bl,4                       ; hi nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ah
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ah,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ah
        ret
HexByte endp

HexWord proc              ; convert hex word to string
        mov  byte ptr [TempBuffer],4    ; string length
        xor  bh,bh
        mov  bl,ah
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+1],ch
        mov  bl,ah
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+2],ch
        mov  bl,al
        shr  bl,4                       ; hi nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+3],ch
        mov  bl,al
        and  bl,0Fh                     ; low nibble
        mov  ch,byte ptr [HexDigit+bx]  ; conversion
        mov  byte ptr [TempBuffer+4],ch
        ret
HexWord endp

OpenFile proc             ; create a new file
        mov  ax,5B02h
        xor  cx,cx                    ; write only
        mov  dx,offset(InputBuffer+2) ; asciiz name
        int  21h                      ; create new file
        jc   @@error
  @@ok:
        mov  FHandle,ax               ; store file handle
        clc                           ; file ok
        ret
  @@error:
        cmp  ax,50h                   ; file already exists error
        je   @@already
  @@error2:
        cmp  ax,03h                   ; path not found error
        je   @@path
        mov  bl,ilmGeneric
        call WriteInfoLine            ; line for generic file error
        jmp  @@exit_
  @@already:
        mov  bl,ilmAlready
        call WriteInfoLine            ; line for file already exists
  @@loop:
        mov  ah,01
        int  16h
        jz   @@loop        ; AL=char read if ZF=0
        mov  ah,00
        int  16h           ; AL=char read

        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   @@rewrite
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        je   @@exit
  @@rewrite:
        mov  ax,3C02h
        mov  dx,offset(InputBuffer+2) ; asciiz name
        xor  cx,cx
        int  21h                      ; create a file
        jc   @@error2
        jmp  @@ok

  @@path:
         mov  bl,ilmPath
         call WriteInfoLine            ; line for path not found
  @@exit_:
         READ_CHAR
  @@exit:stc                           ; file error
         ret
OpenFile endp

SaveFileA proc              ; save the file data (AX=segment) of type A
        mov  es,ax
        mov  ax,0502h               ; Commodore Fast
        mov  word ptr es:[00],ax
        mov  ax,0513h               ; Tape File (ver.1.00)
        mov  word ptr es:[02],ax
        mov  ax,StartAddr
        mov  word ptr es:[04],ax    ; start addrs
        mov  ax,StopAddr
        mov  word ptr es:[06],ax    ; end addrs
        mov  al,CheckSum
        mov  byte ptr es:[08h],al   ; checksum
        mov  ax,es

        mov  bx,FHandle
        mov  cx,FileLength
        add  cx,09h                 ; compensate for header
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h                    ; write cx byte from ds:dx
        pop  ds
        ret
SaveFileA endp

SaveFileB proc              ; save the file data (AX=segment) of type B
        mov  es,ax
        mov  ax,0502h               ; Commodore Fast
        mov  word ptr es:[00],ax
        mov  ax,2513h               ; Tape File (ver.1.01)
        mov  word ptr es:[02],ax
        mov  ax,StartAddr
        mov  word ptr es:[04],ax    ; start addrs
        mov  ax,StopAddr
        mov  word ptr es:[06],ax    ; end addrs
        mov  al,CheckSum
        mov  byte ptr es:[08h],al   ; checksum
        mov  ax,es

        mov  bx,FHandle
        mov  cx,FileLength
        add  cx,09h                 ; compensate for header
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h                    ; write cx byte from ds:dx
        pop  ds
        ret
SaveFileB endp

SaveFileC proc
        mov  bx,FHandle
        mov  cx,FileLength
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h                    ; write cx byte from ds:dx
        pop  ds
        ret
SaveFileC endp

SaveFileD proc              ; save the file data (AX=segment) of type D
        mov  es,ax
        mov  ax,0502h               ; Commodore Fast
        mov  word ptr es:[00],ax
        mov  ax,6513h               ; Tape File (ver.1.03)
        mov  word ptr es:[02],ax
        mov  ax,StartAddr
        mov  word ptr es:[04],ax    ; start addrs
        mov  ax,StopAddr
        mov  word ptr es:[06],ax    ; end addrs
        mov  ax,RTIAddr
        mov  word ptr es:[08h],ax   ; return addrs
        mov  ax,es

        mov  bx,FHandle
        mov  cx,FileLength
        add  cx,0Ah                 ; compensate for header
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h                    ; write cx byte from ds:dx
        pop  ds
        ret
SaveFileD endp

SaveFileE proc
        mov  es,ax
        mov  ax,0502h               ; Commodore Fast
        mov  word ptr es:[00],ax
        mov  ax,8513h               ; Tape File (ver.1.04)
        mov  word ptr es:[02],ax
        mov  ax,es

        mov  bx,FHandle
        mov  cx,FileLength
        push ds
        mov  ds,ax
        xor  dx,dx
        mov  ah,40h
        int  21h                    ; write cx byte from ds:dx
        pop  ds
        ret
SaveFileE endp

AsciiNum proc                   ; convert ascii to numeric value
        cmp  al,'0'
        jb   @@error
        cmp  al,'9'
        ja   @@cont
        sub  al,'0'             ; convert in mumeric format
        clc                     ; no error
        ret
  @@cont:
        and  al,11011111b  ; make char upper
        cmp  al,'A'
        jb   @@error
        cmp  al,'F'
        ja   @@error
        sub  al,'A'-10        ; convert in numeric format
        clc                   ; no error
        ret
  @@error:
        stc                   ; error
        ret
AsciiNum endp

InsertEndAddr proc         ; read end address of program from user
        mov  NormalKeyboard,TRUE
        mov  bl,ilmAddrEnd
        call WriteInfoLine            ; line for input end address
        call ShowCursor               ; show cursor for input
  @@repeat:
        CHANGE_CURSOR_POSITION 1723h
        WRITE_NCHAR ' ', 0Fh, 30
        CHANGE_CURSOR_POSITION 1723h  ; row=24 col.=36
        mov  ah,0Ah
        mov  dx,offset(InputBuffer)
        int  21h                         ; input a string

        cmp  byte ptr [InputBuffer+1],4  ; string length must be 4
        jne  @@repeat

        mov  al,byte ptr [InputBuffer+2]
        call AsciiNum                    ; convert ascii to number
        jc   @@repeat                    ; repear if there's a error
        mov  ah,al
        and  ah,00001111b
        shl  ah,4

        mov  al,byte ptr [InputBuffer+3]
        call AsciiNum                    ; convert ascii to number
        and  al,00001111b
        or   ah,al
        mov  byte ptr [StopAddr+1],ah
        jc   @@repeat                    ; repear if there's a error

        mov  al,byte ptr [InputBuffer+4]
        call AsciiNum                    ; convert ascii to number
        jc   @@repeat                    ; repear if there's a error
        mov  ah,al
        and  ah,00001111b
        shl  ah,4

        mov  al,byte ptr [InputBuffer+5]
        call AsciiNum                    ; convert ascii to number
        jc   @@repeat                    ; repear if there's a error
        and  al,00001111b
        or   ah,al
        mov  byte ptr [StopAddr],ah
        call HideCursor               ; hide cursor
        mov  NormalKeyboard,FALSE
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
        ret
InsertEndAddr endp

CloseFile proc             ; close a file
         mov  ah,3Eh
         mov  bx,FHandle
         int  21h             ; file close
         ret
CloseFile endp

ExitProc proc              ; write exit message and exit from program
        mov  cl,al
        call InitScreen
        mov  dx,offset ProgInfo
        mov  ah,09h
        int  21h               ; write program information
        mov  bl,cl
        xor  bh,bh
        add  bl,bl
        mov  dx,[bx+offset erTable]
        mov  ah,09h
        int  21h               ; write exit message
        mov  al,cl
        mov  ah,4Ch
        int  21h               ; terminate with return code
        ret
ExitProc endp

InitScreen proc                ; Initialize standard screen
        mov  ax,03h            ; Standard Mode
        int  10h
        ret
InitScreen endp

Main:
                            ; set up stack and reduce memory allocation
        lea  bx,EndStack
        mov  cl,4
        shr  bx,cl          ; adjust to program
        inc  bx             ; round up
        mov  ax,ss
        add  bx,ax
        mov  ax,ds
        sub  bx,ax
        mov  ah,4Ah
        int  21h            ; change memory allocation

        mov  ax,@data
        mov  ds,ax

        mov  ah,48h
        mov  bx,4096
        int  21h                      ; get 64K dos memory
        jnc  @@noerror

        mov  al,01h                   ; terminate with 01 error code
        call ExitProc

  @@noerror:
        mov  SegBuffer,ax             ; store segment of buffer

        call InitScreen
        mov  NormalKeyboard,TRUE
	GET_INT_VECT 09h, Int09Save
        SET_INT_VECT 09h, Int09       ; insert int 09 handler

        call WriteVideoMask   ; write video mask page
        call WriteType        ; write the type of file we read
        call HideCursor       ; make the cursor invisible
        call MotorOff
  loop_:
        mov  bl,ilmChoose
        call WriteInfoLine ; line for standard info
        call ChangeError   ; change error with actual error code
  loop__:
        READ_CHAR
        and  al,11011111b  ; make char upper

        cmp  al,'X'        ; exit from program
        je   exit

        cmp  al,'M'        ; motor on/off
        je   motor

        cmp  al,'S'        ; find a file from tape
        je   find_read

        cmp  al,'R'        ; read a file from tape
        je   find_read

        cmp  al,'T'        ; type of file
        je   set_type

        cmp  al,'O'        ; output filename
        je   output

        cmp  al,'W'        ; write file in PC format
        je   write

        jmp  loop__

  motor:
        cmp  MotorFlag,TRUE
        je   motor_off
        call MotorOn                ; make motor on
        jmp  loop_
  motor_off:
        call MotorOff               ; make motor off
        jmp  loop_

  set_type:
        inc  TypeF
        cmp  TypeF,maxType
        jbe  @@nothing
        mov  TypeF,tyA
  @@nothing:
        call WriteType              ; Write Type on screen
        jmp  loop_

  find_read:
        cmp  Status,st3Line         ; is file read but not saved ?
        jne  find_
        mov  bl,ilmNotSaved
        call WriteInfoLine          ; line for file not save
        READ_CHAR
        and  al,11011111b           ; make char upper
        cmp  al,'Y'
        je   find_
        jmp  loop_

  find_:
        call WriteSpace             ; erase old video file information
        call MotorOn                ; make motor on
        mov  bl,ilmPLoad
        call WriteInfoLine          ; line for press tape (loading)
        mov  Status,st1Line
        call ChangeStatus           ; line of no file found
        mov  Error,er1Line
        call ChangeError            ; line of no error
        mov  NormalKeyboard,FALSE
  @@loop:
        cmp  TypeF,tyA
        jne  @@tyB
        call ReadFileA              ; try to find and read a file of type A
        jmp  @@After
  @@tyB:
        cmp  TypeF,tyB
        jne  @@tyC
        call InsertEndAddr          ; read the end address from user
        call ReadFileB              ; try to find and read a file of type B
        jmp  @@After
  @@tyC:
        cmp  TypeF,tyC
        jne  @@tyD
        call ReadFileC              ; try to find and read a file of type C
        jmp  @@After
  @@tyD:
        cmp  TypeF,tyD
        jne  @@tyE
        call ReadFileD              ; try to find and read a file of type D
        jmp  @@After
  @@tyE:
        call ReadFileE              ; try to find and read a file of type E
  @@After:
        cmp  StopRead,TRUE          ; if interrupt by ESC key
        je   error_ilmStop          ; go error message

  correct_header:

        call MotorOff               ; make motor off
        call RestoreAttribute
        mov  NormalKeyboard,TRUE
        mov  Status,st3Line
        call ChangeStatus           ; line of one file read (not saved)
        call WriteFileInfo          ; write info about file

        cmp  TypeF,tyA              ; is Type A of file ?
        jne  @@tyB
  @@Check:
        mov  al,Chk
        xor  al,CheckSum            ; verify for checksum
        je   loop_
        jmp  CheckSumError
  @@tyB:
        cmp  TypeF,tyB              ; is Type B of file ?
        je   @@Check
  @@tyC:
        jmp  loop_

  CheckSumError:
        mov  Error,er2Line
        call ChangeError            ; line for checksum error
        mov  bl,ilmChk
        call WriteInfoLine          ; line for checksum error
        READ_CHAR
        jmp  loop_

  error_ilmStop:
        call RestoreAttribute
        mov  bl,ilmStop
        call WriteInfoLine          ; line for interrupt by ESC key
        mov  Status,stNormal
        call ChangeStatus           ; line for normal status
        mov  Error,er4Line
        call ChangeError            ; line for stop by esc
        mov  Error,erNormal
        mov  NormalKeyboard,TRUE
        mov  StopRead,FALSE
        call MotorOff               ; make motor off
        READ_CHAR
        jmp  loop_

  output:
        mov  bl,ilmInput
        call WriteInfoLine            ; line for input name file
        call ShowCursor               ; show cursor for input
        call InputName                ; enter name file
        call HideCursor               ; hide cursor
        call SplitName                ; estract component of file name
        cmp  byte ptr [FName],0       ; there's not name ?
        jz   Error_ilmFile            ; then error
        mov  bl,ilmChoose
        call WriteInfoLine            ; line for standard info
        cmp  byte ptr [FExtension],0  ; there's not extension ?
        jnz  there_is_ext
        mov  byte ptr [FExtension],4
        mov  byte ptr [Fextension+1],'.'
        mov  byte ptr [FExtension+2],'T'
        mov  byte ptr [FExtension+3],'@'
        mov  byte ptr [FExtension+4],'0'
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],'.'
        mov  byte ptr [bx+InputBuffer+3],'T'
        mov  byte ptr [bx+InputBuffer+4],'@'
        mov  byte ptr [bx+InputBuffer+5],'0'
        mov  byte ptr [bx+InputBuffer+6],0   ; asciiz string
        jmp  update_video_name
  there_is_ext:
        mov  bl,byte ptr [InputBuffer+1]     ; actual length
        xor  bh,bh
        mov  byte ptr [bx+InputBuffer+2],0   ; asciiz string
  update_video_name:
        call UpdateFileName              ; write actul file name into his line
        mov  OutFileSet,TRUE             ; the file name is set
        jmp  loop_

  Error_ilmFile:
        mov  bl,ilmFile
        call WriteInfoLine               ; line for error in file name
        mov  byte ptr [FName],4
        mov  byte ptr [FName+1],'n'
        mov  byte ptr [FName+2],'o'
        mov  byte ptr [FName+3],'n'
        mov  byte ptr [FName+4],'e'
        mov  byte ptr [FExtension],1
        mov  byte ptr [FExtension+1],' '
        call UpdateFileName             ; write actul file name into his line
        mov  OutFileSet,FALSE           ; the file name is non set
        READ_CHAR
        jmp  loop_

  write:
        cmp  Status,st3Line         ; there's a file read ?
        jz   @@cont
        mov  bl,ilmNoSave
        call WriteInfoLine          ; line for no save error
  @@wait:
        READ_CHAR
        jmp  loop_
  @@cont:
        cmp  OutFileSet,TRUE        ; there's a good name set ?
        je   @@cont2
        mov  bl,ilmNoName
        call WriteInfoLine
        jmp  @@wait
  @@cont2:
        call OpenFile               ; create a new file
        jc   loop_                  ; jump if error opening file
        mov  ax,SegBuffer           ; set appropriate segment

        cmp  TypeF,tyA
        jne  @@tyB_
        call SaveFileA              ; save the file
        jc   @@close                ; jump if error writing file
        jmp  @@okClose
  @@tyB_:
        cmp  TypeF,tyB
        jne  @@tyC_
        call SaveFileB             ; save the file of type B
        jc   @@close               ; jump if error writing file
        jmp  @@okClose
  @@tyC_:
        cmp  TypeF,tyC
        jne  @@tyD_
        call SaveFileC             ; save the file of type C
        jc   @@close               ; jump if error writing file
        jmp  @@okClose
  @@tyD_:
        cmp  TypeF,tyD
        jne  @@tyE_
        call SaveFileD             ; save the file of type D
        jc   @@close               ; jump if error writing file
        jmp  @@okClose
  @@tyE_:
        call SaveFileE             ; save the file of type E
        jc   @@close               ; jump if error writing file
        jmp  @@okClose
  @@okClose:
        mov  Status,stNormal
        call WriteSpace             ; erase video file information
        call ChangeStatus           ; line for normal status
        mov  Error,erNormal
        call ChangeError            ; line for normal error
  @@close:
        call CloseFile              ; close a file
        jmp  loop_

  exit: cmp  Status,st3LIne         ; is a file read but not saved
        jne  goexit
        mov  bl,ilmExit             ; line for exit but not saved
        call WriteInfoLine
        READ_CHAR
        and  al,11011111b  ; make char upper
        cmp  al,'Y'
        je   goexit
        jmp  loop_


  goexit:
        call ShowCursor
        SET_INT_VECT 09h, Int09Save, []   ; insert int 09 Bios
        xor  al,al
        call ExitProc          ; terminate with return code
end Main

PROC:

ChangeError          change color of error line
ChangeStatus         change color of status line
CloseFile            close a file
ExitProc             write exit message and exit from program
HexByte              convert hex byte to string
HexWord              convert hex word to string
HideCursor           make the cursor invisible
InputName            read input file name by keyboard
InitScreen           inizialize standard screen
InsertEndAddr        read end address of rpogram from user
MotorOff             off the cassette motor
MotorOn              on the cassette motor
OpenFile             create a new file
ReadBitA             read one bit (carry=bit read) of type A
ReadBitB             read one bit (carry=bit read) of type B
ReadCharA            read one character of type A
ReadCharB            read one character of type B
ReadCharA_           read AL bit of type A
ReadFileA            read the file block of type A
ReadFileB            read the file block of type B
RestoreAttribute     restore black attribute to video
SaveFileA            save file of type A
ShowCursor           make the cursor visible
SplitName            split file name component
StringCopy           copy one string (ds:si) in another (es:di)
UpdateFileName       write actul file name into his line
WriteFileInfo        write info about header of tape file to video
WriteInfoLine        write message into info line (BL set message)
WriteNumInfo         write numeric string info
WriteSpace           erase video file information
WriteVideoMask       write the video mask

File Format:
   output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       05h        : File
                     : version 1.00
 04       shi        : Start address low
 05       slo        : Start address hi
 06       ehi        : End address low
 07       elo        : End address hi
 08       chk        : checksum
 09       data
 ::       ::         : file data
 eof      data

output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       25h        : File
                     : version 1.01
 04       shi        : Start address hi
 05       slo        : Start address low
 06       ehi        : End address hi
 07       elo        : End address low
 08       chk        : checksum
 09       data
 ::       ::         : file data
 eof      data

 output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       45h        : File
                     : version 1.02
 ::       ::         : file data
 eof      data

output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       45h        : File
                     : version 1.03
 04       shi        : Start address hi
 05       slo        : Start address low
 06       ehi        : End address hi
 07       elo        : End address low
 08       data
 ::       ::         : file data
 eof      data

output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       85h        : File
                     : version 1.04
 Block0:
 04        tyb        : Block Type
 05+tyb-04 ext        : extra byte
 05+tyb-03 shi        : Start address hi
 06        slo        : Start address low
 07        ehi        : End address hi
 08        elo        : End address low
 09        data
 ::        ::         : file data
 xx       data
 Block1:...

output file .T@0:
 00       02h        : Commodore 64
 01       05h        : Fast
 02       13         : Tape
 03       45h        : File
                     : version 1.03


08/12/97 1:15        : routine per read char e schermo
09/12/97   45        : sistemazione maschera video
15/12/97   20        : inserimento routine gi fatte per reader ver 1.00
16/12/97   55        : inserimento e modifica ciclo main
01/01/98   25        : modifiche per lettura metodo A
                10   : verifica lettura A
02/01/98   25        : routine per lettura B (bit/char/file)
20/01/98   20        : routine per lettura C (bit/char/~file)
21/01/98   55        : routine per lettura D/E
24/01/98        50   : verifica B,C,D,E
           50        : lettura stopaddr per B
15/01/98   15        : routine per save B
04/02/98   20        : modifiche per stampare etichetta dei metodi
13/02/98   10   10   : aggiunte per metodo C
14/02/98   10    5   : aggiunte per metodo D
15/02/98   15   10   : aggiunte per metodo E
20/02/98   15        : aggiunte metodo E per tipo blocco 03/04
21/02/98   20   10   : modifiche E per sx dx
22/02/98    5        : aggiunta block number
         ----
         8:10 1:35

CFTF 1.00 => (A) Critical Mass
CFTF 1.01 => (B) Little Girl
CFTF 1.02 => (C) Last Ninja II
CFTF 1.03 => (D) Megamoto
CFTF 1.04 => (E) Master Chees